<?php

namespace Ems\Controllers;

use Ems\Services\ImportacaoAFDService;
use Ems\Util\ExpectedException;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\{ Message, Error };

class ImportacaoAFDController {
     /** @var ImportacaoAFDService */
    protected $importacaoAFDService;

    public function __construct(ImportacaoAFDService $importacaoAFDService) {
        $this->importacaoAFDService = $importacaoAFDService;
    }

    public function importacaoAFD(DTO\Request\Row $request, DTO\Response $response) { 
        var_dump('aqui importacaoAFD. Controller');
        
        try {
            $row = $request->getRow();

            if(empty($row['dataBase64AFD']))
                throw new \Exception('Arquivo AFD não localizado. Favor enviar o arquivo em formato base64.');

            $dataAFD = base64_decode($row['dataBase64AFD']);

            $mensagem = $this->importacaoAFDService->importacaoAFD($dataAFD);

            if(array_key_exists('erro', $mensagem)){
                $message = new \Zeedhi\Framework\DTO\Response\Message($mensagem['erro'], 'E');
                $response->addMessage($message);
            }
            if($mensagem['sucesso']){
                $message = new \Zeedhi\Framework\DTO\Response\Message($mensagem['sucesso'], 'S');
                $response->addMessage($message);
            }

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    /*public function getResumoFreq(
        DTO\Request\Row $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getRow();
            $nrVinculo = (int) $row['NRVINCULOM'];
            $date = (string) $row['DATE'];

            $resumo = $this->apuracaoService->getResumoDiaSituFreqVinculo(
                $nrVinculo, $date
            );

            $response->addDataSet(new DataSet('getResumoFreq', $resumo));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }*/

}