<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoDadosPessoa extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrvinculom     = $this->getSolicitacao()->getNrvinculom();
        $dtcompetencia  = DateUtil::getDataDeString(Utils::getParamters()->getDtmescomptencDiaCorrente(),DateUtil::FORMATO_BRASILEIRO,true);
            
        $vinculom = Utils::getEntityManager()->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array("nrorg"=> Utils::getParamters()->getNrorg(),"nrvinculom" => $nrvinculom));
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_PESSOA)->findOneBy(array("nrorg"=> Utils::getParamters()->getNrorg(),"nrpessoa" => $vinculom->getNrpessoa()));

        $pessoaHistorico = ProcessamentoSolicitacaoUtil::retornaHistoricoAtualPorPessoa(Utils::getParamters()->getNrorg(),$result->getNrpessoa(),$dtcompetencia);
        
        $nrcertcasapes      = $itens['NRCERTCASAPES']           ?? $pessoaHistorico->getNrcertcasapes();
        $nrgrauinstr        = $itens['NRGRAUINSTR']             ?? $pessoaHistorico->getNrgrauinstr();
        $dspessoa           = $itens['DSPESSOA']                ?? $itens['NMPESSOA'] ?? $pessoaHistorico->getNmpessoa();
        $nrcarthabpes       = $itens['NRCARTHABPES']            ?? $pessoaHistorico->getNrcarthabpes();
        $dscateghabcart     = $itens['DSCATEGHABCART']          ?? $pessoaHistorico->getDscateghabcart();
        $dtcasapessoa       = isset($itens['DTCASAPESSOA'])     ? DateUtil::getDataDeString(substr($itens['DTCASAPESSOA'],0,10), DateUtil::FORMATO_BRASILEIRO, true)    : $pessoaHistorico->getDtcasapessoa();
        $dthabcartpes       = isset($itens['DTHABCARTPES'])     ? DateUtil::getDataDeString(substr($itens['DTHABCARTPES'],0,10), DateUtil::FORMATO_BRASILEIRO, true)    : $pessoaHistorico->getDthabcartpes();
        $dtvalhabcartpes    = isset($itens['DTVALHABCARTPES'])  ? DateUtil::getDataDeString(substr($itens['DTVALHABCARTPES'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : $pessoaHistorico->getDtvalhabcartpes();;

        if($pessoaHistorico->getDtmescompetenc() == $dtcompetencia){
            
            $pessoaHistorico->setNmpessoa($dspessoa);
            $pessoaHistorico->setNrcertcasapes($nrcertcasapes);
            $pessoaHistorico->setNrgrauinstr($nrgrauinstr);
            $pessoaHistorico->setNrcarthabpes($nrcarthabpes);
            $pessoaHistorico->setDscateghabcart($dscateghabcart);
            $pessoaHistorico->setDtcasapessoa($dtcasapessoa);
            $pessoaHistorico->setDthabcartpes($dthabcartpes);
            $pessoaHistorico->setDtvalhabcartpes($dtvalhabcartpes);
            $pessoaHistorico->setDtultatu(DateUtil::getDataAtual(false));
            $pessoaHistorico->setNrorgultatu(Utils::getParamters()->getNrorg());
            $pessoaHistorico->setCdoperultatu(Utils::getParamters()->getCdoperador());
            
            Utils::getEntityManager()->persist($pessoaHistorico);
            Utils::getEntityManager()->flush();
        }
        else{
            ProcessamentoSolicitacaoUtil::novoHistoricoPessoa(
                Utils::getParamters()->getNrorg(),$pessoaHistorico->getNrpessoa(),$dtcompetencia,$dspessoa,$pessoaHistorico->getDsapelidopess(),$pessoaHistorico->getNrcertnascpes(),$pessoaHistorico->getDtnascpessoa(),
                $pessoaHistorico->getIdsexopessoa(),$pessoaHistorico->getNrcondfispes(),$pessoaHistorico->getNrcpfpessoa(),$pessoaHistorico->getNrctpspessoa(),$pessoaHistorico->getNrseriectpspes(),$pessoaHistorico->getSgufctpspes(),
                $pessoaHistorico->getDtctpspessoa(),$pessoaHistorico->getNrpispaseppes(),$pessoaHistorico->getDtinscpispasep(),$pessoaHistorico->getNrinscinsspes(),$pessoaHistorico->getNrinscisspes(),$pessoaHistorico->getCdestacivil(),
                $nrcertcasapes,$dtcasapessoa,$pessoaHistorico->getIdisentituelei(),$pessoaHistorico->getNrtitueleipes(),$pessoaHistorico->getNrsecaeleipes(),$pessoaHistorico->getNrzonaeleipes(),
                $nrcarthabpes,$dthabcartpes,$dtvalhabcartpes,$dscateghabcart,$pessoaHistorico->getNrcatmilitarpe(),$pessoaHistorico->getNrcertresepes(),
                $pessoaHistorico->getDscategcertrese(),$pessoaHistorico->getDtcertresepes(),$pessoaHistorico->getCdexcertresepes(),$pessoaHistorico->getNrracapessoa(),$pessoaHistorico->getIdgrupsangupes(),$pessoaHistorico->getIdfatorrhpes(),
                $pessoaHistorico->getCdpais(),$pessoaHistorico->getSgestado(),$pessoaHistorico->getCdmunicipio(),$pessoaHistorico->getNrrgpessoa(),$pessoaHistorico->getCdexrgpessoa(),$pessoaHistorico->getSgufrgpessoa(),
                $pessoaHistorico->getDslocalexrgpes(),$pessoaHistorico->getDtexrgpessoa(),$pessoaHistorico->getNrnacionalid(),$nrgrauinstr,$pessoaHistorico->getDspronometrat() ,$pessoaHistorico->getNranochegapais() ,
                $pessoaHistorico->getNrdocuestrang(),$pessoaHistorico->getIdpesnaturaliza(),$pessoaHistorico->getDtnaturalizapes(),$pessoaHistorico->getIdposvistoperm(),$pessoaHistorico->getDtpermavisto(),$pessoaHistorico->getNrconselhoreg(),
                $pessoaHistorico->getNrinscrconsreg(),$pessoaHistorico->getDtexconsreg(),$pessoaHistorico->getSgufconsreg(),$pessoaHistorico->getCdtpbaixapag(),$pessoaHistorico->getNrlivrocertnasc(),
                $pessoaHistorico->getNrfolhacertnasc(), $pessoaHistorico->getDscomplcertnasc(),$pessoaHistorico->getNrregctpspes()
            );
        }
        
        if($vinculom->getNmvinculom() != $dspessoa){
            $vinculom->setNmvinculom($dspessoa);
            Utils::getEntityManager()->persist($vinculom);
            Utils::getEntityManager()->flush();
        }
    }
    
    public function rejeitar() {}
}