<?php

namespace Ems\Services;

use Util\Environment;
use Ems\Repository\IndicadoresSegurancaTrabalhoRepository;

class IndicadoresSegurancaTrabalhoService {

    /** @var Environment */
    protected $environment;

    /** @var IndicadoresSegurancaTrabalhoRepository */
    protected $indicadoresSegurancaTrabalhoRepository;


    public function __construct(
        Environment                    $environment,
        IndicadoresSegurancaTrabalhoRepository $indicadoresSegurancaTrabalhoRepository
    )
    {
        $this->environment                    = $environment;
        $this->indicadoresSegurancaTrabalhoRepository = $indicadoresSegurancaTrabalhoRepository;
    }

    public function getTotalAcidentes($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentes(
            $row
        );

        return $totais;
    }

    public function getTotalAcidentesGerenOcup($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentesGerenOcup(
            $row
        );

        return $totais;
    }

    public function getTotalAcidentesOcupacaoGeral($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentesOcupacaoGeral(
            $row
        );

        return $totais;
    }

    public function getTotalAcidentesPorGravidadeLegalOcupacao($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentesPorGravidadeLegalOcupacao(
            $row
        );

        return $totais;
    }

    public function getTotalAcidentesPorGravidadeGerenOcup($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentesPorGravidadeGerenOcup(
            $row
        );

        return $totais;
    }

    public function getTotalAcidentesPorGravidadeOcupacaoGeral($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalAcidentesPorGravidadeOcupacaoGeral(
            $row
        );

        return $totais;
    }

    public function getQuantidadeDiasAfastadosLegalOcup($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getQuantidadeDiasAfastadosLegalOcup(
            $row
        );

        return $totais;
    }

    public function getQuantidadeDiasAfastadosOcupacaoGeral($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getQuantidadeDiasAfastadosOcupacaoGeral(
            $row
        );

        return $totais;
    }

    public function getTotalPartesDoCorpoAtingidasLegalOcup($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalPartesDoCorpoAtingidasLegalOcup(
            $row
        );

        return $totais;
    }

    public function getTotalPartesDoCorpoAtingidasOcupacaoGeral($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getTotalPartesDoCorpoAtingidasOcupacaoGeral(
            $row
        );

        return $totais;
    }

    public function getSituacaoGeradoraAcidenteLegalOcup($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getSituacaoGeradoraAcidenteLegalOcup(
            $row
        );

        return $totais;
    }

    public function getSituacaoGeradoraAcidenteOcupacaoGeral($row)
    {   

        $totais = $this->indicadoresSegurancaTrabalhoRepository->getSituacaoGeradoraAcidenteOcupacaoGeral(
            $row
        );

        return $totais;
    }

    
    

}