<?php

namespace HCM\FPA\Util;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\FPA\Entity\FpatipocalculoEntity;

class MemoriaRateio{

    private static $instance = null;
    private static $contador = 0;
    
    private $nomeArquivo = null;
    private $escopoGeral = [];
    private $escopoVinc = [];
    private $escopoInfo = null;
    
    private $resultadoTotal;
    
    private $referencia;
    
    private $infoBenefVinc = [];
    private $infoCalculo = [];
    
    private $vinculo;
    private $dtPagamento;

    private $arquivo;
    
    
    public function inicializarDados($qntdVinculo,$porcentagemOcupacao,$porcentagemEstrutGeren,$vinculo,$nrvinculom,$ocupacao,$estrutura){
       
        $this->qntdVinculo = $qntdVinculo;
        $this->porcentagemEstrutGeren = $porcentagemEstrutGeren;
        $this->porcentagemOcupacao = $porcentagemOcupacao;
        $this->vinculo = $vinculo;
        $this->nrvinculom = $nrvinculom;
        $this->ocupacao = $ocupacao;
        $this->estrutura = $estrutura;
    }
    
    public static function getInstance() {
        if (self::$instance === null) {
            self::$contador++;
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
        self::$contador = 0;
    }
    

    public function getCaminhoArquivo(){
        return $this->arquivo;
    }
    
    public function mensagemInfoVinculo(){
            $this->escopoVinc = 
            PHP_EOL.PHP_EOL.
            '=-=-=-=-=-=-=- INFORMAÇÃO'.self::$contador.' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
            '_______________ ::::: Dados do Rateio ::::: _______________'.PHP_EOL.PHP_EOL.
            '* Vínculo: '.$this->nrvinculom.' - '.$this->vinculo.PHP_EOL.PHP_EOL.
            '* % Estruturas'.'('.$this->estrutura.')'.': '.$this->porcentagemEstrutGeren.PHP_EOL.
            '* % Ocupações'.'('.$this->ocupacao.')'.': '.$this->porcentagemOcupacao.PHP_EOL.PHP_EOL.
            '_______________ ::::: Informações do Calculo de Rateio ::::: _______________'.PHP_EOL.PHP_EOL.
            'Formula de Calculo: ((Valor De Lançamentos * (%Estruturas/100))*(% Ocupações/100))/Qntd. Vínculos'.PHP_EOL.PHP_EOL;
        self::$contador++;
        
        return $this->escopoVinc;
    }
    
    
    public function mensagemInfoRateio($dtLanc,$vrLanc){
        
        $this->escopoInfo =
            '-__--__--__--__--__--__--__--__--__--__--__--__--__--__--__-__--__-__--__-__--__-__--__-'.PHP_EOL.
            '* Dia '.$dtLanc.PHP_EOL.
            '* Valor do Lançamento: '.$vrLanc.PHP_EOL.
            '* Qntd. Vínculos: '.$this->qntdVinculo.PHP_EOL.PHP_EOL.
            'Calculo Executado: (('.$vrLanc.'*('.$this->porcentagemEstrutGeren.'/100))*('.$this->porcentagemOcupacao.'/100))/'.$this->qntdVinculo.PHP_EOL.PHP_EOL.
            'Resultado: '.(($vrLanc*($this->porcentagemEstrutGeren/100))*($this->porcentagemOcupacao/100))/$this->qntdVinculo.PHP_EOL.PHP_EOL;
        
        return $this->escopoInfo;
    }
    
    public function mensagemInfoNaoGeraRateio($situFuncNaoGeraRateio,$tipoVincNaoGeraRateio,$vincEmpregNaoGeraRateio){
        if($situFuncNaoGeraRateio){
            foreach($situFuncNaoGeraRateio as $vinculo){
                $vinculoSituFuncArr[] = $vinculo;
            }
        }
        if($tipoVincNaoGeraRateio){
            foreach($tipoVincNaoGeraRateio as $tipoVinc){
                $tipoVincArr[] = $tipoVinc;
            }
        }
        if($vincEmpregNaoGeraRateio){
            foreach($vincEmpregNaoGeraRateio as $vincEmpreg){
                $vincEmpregArr[] = $vincEmpreg;
            }
        }
        $vinculoSituFuncArr[] = '';
        $tipoVincArr[] = '';
        $vincEmpregArr[] = '';
        
        $this->escopoInfoNaoGeraRateio =
            '=============================================================================================================='.PHP_EOL.
            '=-=-=-=-=-=-=- VINCULOS COM SITUAÇÕES FUNCIONAIS QUE NÃO GERAM RATEIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
            implode(PHP_EOL,$vinculoSituFuncArr).PHP_EOL.PHP_EOL.
            '=============================================================================================================='.PHP_EOL.
            '=-=-=-=-=-=-=- VINCULOS COM TIPOS DE VINCULOS QUE NÃO GERAM RATEIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
            implode(PHP_EOL,$tipoVincArr).PHP_EOL.PHP_EOL.
            '=-=-=-=-=-=-=- VINCULOS COM VINCULOS EMPREGATICIOS QUE NÃO GERAM RATEIO -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
            implode(PHP_EOL,$vincEmpregArr).PHP_EOL.PHP_EOL;
            
        return $this->escopoInfoNaoGeraRateio;
    }
    
    public function salvarMsgArquivo($mensagemMemoriaDeCalculo){
        $this->arquivo = FPA::getTempDirectory().'/Memoria_Rateio  Execucao('.DateUtil::getDataAtual()->format('d-m-Y H:i:s').').txt';
        file_put_contents($this->arquivo, $mensagemMemoriaDeCalculo);
    }

}