<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class ESocialItensPeriodRepository {

    protected  $connection;

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getItensParaEnvioS1200($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT DISTINCT VM.NRPESSOA as NRCHAVE,
       DECODE(CF.NRTIPOMOVIMENT,4,(CASE WHEN TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NROCORRECAL = 1 THEN '4' ELSE '1'END), '1') as NRTABELA,
       'I' as IDOPERACAO,
       CF.DTOCORRENCIA as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    AND SUBSTR(EH.CDCNPJESTRUT,1,8) = (SELECT SUBSTR(EP.CDCNPJESTRUT,1,8) FROM ESTRUTURAH EP
                                                        WHERE EP.NRORG = :P_NRORG
                                                          AND EP.NRESTRUTURAM = :P_NRESTRUTURAM
                                                          AND EP.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                                    WHERE H1.NRESTRUTURAM = EP.NRESTRUTURAM
                                                                                      AND H1.NRORG = EP.NRORG
                                                                                      AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC))
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND ((CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND :P_NRTABELA = 4 AND CF.NROCORRECAL = 1/*OCORRENCIA 1 PARA DESCONSIDERAR 13 COMPLEMENTAR*/) OR
                               ((CF.NRTIPOMOVIMENT IN (1,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND (TO_CHAR(CF.DTOCORRENCIA,'MM') <> '12' OR (TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'AND CF.NROCORRECAL <> 1)))) AND :P_NRTABELA = 1) OR 
                               (:P_NRTABELA IS NULL AND CF.NRTIPOMOVIMENT IN (1,4,10,19)))
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
  LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = EH.NRESTRUTURAM
                               AND ESOPARAMS.NRORG = EH.NRORG 
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (VM.NRTIPOVINCULOM = 1 OR (VM.NRTIPOVINCULOM IN (2,10) AND (CF.NRTIPOMOVIMENT = 1 OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
        OR VM.NRTIPOVINCULOM = 3 AND (CF.NRTIPOMOVIMENT IN (1,19) OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 1) OR
        ((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= LAST_DAY(:P_DTMESCOMPETENC)) AND IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT <> 1) OR
        (VM.DTRESCISAOVINC < :P_DTMESCOMPETENC AND IT.NREVENTOM = 3050 AND CF.NRTIPOMOVIMENT = 1))
   AND EXISTS (
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                  /*CP NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) CP ON CP.NREVENTOM = EMC.NREVENTOM
                                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                  /*IRRF NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) IRRF ON IRRF.NREVENTOM = EMC.NREVENTOM
                                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
                   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
   AND ((IT.NREVENTOM = 3050 AND ESOPARAMS.IDAPROVACALCRESC = 'S' AND EXISTS(SELECT 1
                                                                               FROM FPA_ITECALCFOLHA ITFEC 
                                                                              WHERE ITFEC.NRORG = VH.NRORG
                                                                                AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                                                                                AND ITFEC.NREVENTOM = 3035
                                                                                AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)) 
        OR NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N'
        OR IT.NREVENTOM <> 3050)
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
 ORDER BY 1,2
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                    "P_NRPESSOA" => isset($params['NRPESSOA']) ? $params['NRPESSOA'] : null,
                    "P_NRTABELA" => isset($params['NRTIPOMOVIMENT']) ? $params['NRTIPOMOVIMENT'] : null
                );
                
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getItensParaEnvioS1210($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT DISTINCT VM.NRPESSOA as NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    AND SUBSTR(EH.CDCNPJESTRUT,1,8) = (SELECT SUBSTR(MAX(EP.CDCNPJESTRUT),1,8) FROM ESTRUTURAH EP
                                                        WHERE EP.NRORG = :P_NRORG
                                                          AND EP.NRESTRUTURAM = :P_NRESTRUTURAM
                                                          AND EP.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                                    WHERE H1.NRESTRUTURAM = EP.NRESTRUTURAM
                                                                                      AND H1.NRORG = EP.NRORG
                                                                                      AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC))
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
  LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = EH.NRESTRUTURAM
                               AND ESOPARAMS.NRORG = EH.NRORG
  /*Movimentacao de saida*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = 1
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                  AND EHS.NRVINCULOM = VH.NRVINCULOM
  /*Movimentacao de entrada*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = 1
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8) EHN ON EHN.NRORG = VH.NRORG
                                              AND EHN.NRVINCULOM = VH.NRVINCULOM  
                                              AND EHN.DTINIMOVIMENT >= EHS.DTINIMOVIMENT                                          
                                              AND SUBSTR(EHN.CDCNPJESTRUT,1,8) <> SUBSTR(EHS.CDCNPJESTRUT,1,8)                               
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND EXISTS (
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                  /*CP NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) CP ON CP.NREVENTOM = EMC.NREVENTOM
                                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                  /*IRRF NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) IRRF ON IRRF.NREVENTOM = EMC.NREVENTOM
                                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
                   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
   AND ((NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N')
        OR (IT.NREVENTOM = 3050 AND ESOPARAMS.IDAPROVACALCRESC = 'S' 
            AND EXISTS(SELECT 1
                         FROM FPA_ITECALCFOLHA ITFEC 
                        WHERE ITFEC.NRORG = VH.NRORG
                          AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                          AND ITFEC.NREVENTOM = 3035
                          AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)
             )
        OR IT.NREVENTOM <> 3050) 
   AND ((NVL(ESOPARAMS.IDAPROVACALCFERIAS, 'N') = 'N')
        OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 2 AND ESOPARAMS.IDAPROVACALCFERIAS = 'S'
            AND EXISTS(SELECT 1
                         FROM FPA_ITECALCFOLHA ITFEC 
                        WHERE ITFEC.NRORG = VH.NRORG
                          AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                          AND ITFEC.NREVENTOM = 3035
                          AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)
             )
        OR CF.NRTIPOMOVIMENT <> 2) 
   AND EHN.DTINIMOVIMENT IS NULL
   AND EHS.DTINIMOVIMENT IS NULL
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
UNION ALL
/*Vinculos que tiveram movimentacao de saida na competencia e tem remuneracao anterior*/
SELECT DISTINCT VM.NRPESSOA AS NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, EM.NMESTRUTURAM, EH.CDCNPJESTRUT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = 1
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EH ON EH.NRORG = VH.NRORG
                                                                                                  AND EH.NRVINCULOM = VH.NRVINCULOM
                                                                                                  AND SUBSTR(EH.CDCNPJESTRUT,1,8) = (SELECT SUBSTR(max(EP.CDCNPJESTRUT),1,8) FROM ESTRUTURAH EP
                                                                                                                                      WHERE EP.NRORG = :P_NRORG
                                                                                                                                        AND EP.NRESTRUTURAM = :P_NRESTRUTURAM
                                                                                                                                        AND EP.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                                                                                                                  WHERE H1.NRESTRUTURAM = EP.NRESTRUTURAM
                                                                                                                                                                    AND H1.NRORG = EP.NRORG
                                                                                                                                                                    AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC))
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND EXISTS (/*getDadosS1200itensRemun*/
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                  /*CP NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) CP ON CP.NREVENTOM = EMC.NREVENTOM
                                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                  /*IRRF NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) IRRF ON IRRF.NREVENTOM = EMC.NREVENTOM
                                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
                   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
UNION ALL
/*Vinculos que tiveram movimentacao de entrada e remuneracao na competencia */
SELECT DISTINCT VM.NRPESSOA AS NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
/*Movimentação de entrada*/
 JOIN (SELECT  MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAH EH ON EH.NRORG = MO.NRORG
                                 AND EH.NRESTRUTURAM = MO.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = 1
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHN ON EHN.NRORG = VH.NRORG
                                                                                                   AND EHN.NRVINCULOM = VH.NRVINCULOM
                                                                                                   AND SUBSTR(EHN.CDCNPJESTRUT,1,8) = (SELECT SUBSTR(MAX(EP.CDCNPJESTRUT),1,8) FROM ESTRUTURAH EP
                                                                                                                                      WHERE EP.NRORG = :P_NRORG
                                                                                                                                        AND EP.NRESTRUTURAM = :P_NRESTRUTURAM
                                                                                                                                        AND EP.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                                                                                                                  WHERE H1.NRESTRUTURAM = EP.NRESTRUTURAM
                                                                                                                                                                    AND H1.NRORG = EP.NRORG
                                                                                                                                                                    AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC))
  /*Movimentacao de saida*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAH EH ON EH.NRORG = MO.NRORG
                                 AND EH.NRESTRUTURAM = MO.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = 1
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                   AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
   AND EXISTS (/*getDadosS1200itensRemun*/
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                  /*CP NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) CP ON CP.NREVENTOM = EMC.NREVENTOM
                                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                  /*IRRF NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) IRRF ON IRRF.NREVENTOM = EMC.NREVENTOM
                                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
                   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
 ORDER BY 1
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                    "P_NRPESSOA" => isset($params['NRPESSOA']) ? $params['NRPESSOA'] : null,
                );
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getItensParaEnvioS1250($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT PR.NRESTRUTESTAB as NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       PR.DTMESCOMPETENC as DTMESCOMPETENC,
       SUM(PR.VRBRUTOAQUIS) VRBRUTOAQUIS
  FROM ESO_AQUIPRODRURAL PR
 WHERE PR.NRORG = :P_NRORG
   AND PR.NRESTRUTEMPREG = :P_NRESTRUTURAM
   AND PR.DTMESCOMPETENC = :P_DTMESCOMPETENC
 GROUP BY PR.NRESTRUTESTAB, PR.DTMESCOMPETENC
 ORDER BY 1
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                );
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getItensParaEnvioS1280($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT DISTINCT EM.NRESTRUTURAM as NRCHAVE,
       DECODE(CF.NRTIPOMOVIMENT,4,'4','1') as NRTABELA,
       'I' as IDOPERACAO,
       CF.DTOCORRENCIA as DTMESCOMPETENC
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = EM.NRORG
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                          AND (CF.NRTIPOMOVIMENT IN (1,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'))
                          AND CF.NRTPMODALIDCAL = 1
  JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
   AND (EM.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL)
   /*Empresas substituida o parcialmente substrituida, com valor de aliquota de desoneracao ou optante do simples*/
   AND (CT.CDESOCIAL IN ('01','03','12') OR EH.VRALIQDESON IS NOT NULL OR EH.IDOPTSIMPLES = 'S')
 ORDER BY 1,2
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                );
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getItensParaEnvioS1295($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT DISTINCT EM.NRESTRUTURAM as NRCHAVE,
       DECODE(CF.NRTIPOMOVIMENT,4,'4','1') as NRTABELA,
       'I' as IDOPERACAO,
       CF.DTOCORRENCIA as DTMESCOMPETENC
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = EM.NRORG
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                          AND (CF.NRTIPOMOVIMENT IN (1,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'))
                          AND CF.NRTPMODALIDCAL = 1
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
   AND (EM.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL)
 ORDER BY 1,2
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                );
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getItensParaEnvioS1300($params) {
        try {
            // Só envia itens se for CNPJ Matriz ou se for outro tipo de inscrição
            $idMatriz = isset($params['IDMATRIZ']) ? $params['IDMATRIZ'] : 'S';
            if ($idMatriz == 'S') {
                $sql = <<<SQL
SELECT DISTINCT EM.NRESTRUTURAM as NRCHAVE,
       DECODE(CF.NRTIPOMOVIMENT,4,'4','1') as NRTABELA,
       'I' as IDOPERACAO,
       CF.DTOCORRENCIA as DTMESCOMPETENC
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = EM.NRORG
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
                          AND (CF.NRTIPOMOVIMENT IN (1,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'))
                          AND CF.NRTPMODALIDCAL = 1
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
   AND (EM.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL)
 ORDER BY 1,2
SQL;
                $params = array(
                    "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                    "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                    "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
                    "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                );
                return $this->connection->fetchAll($sql, $params);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

}