<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Util\Environment;

class S1210Repository {

    protected  $connection;

    public function __construct(EntityManager $entityManager, Environment $environment) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }
    
    public function getItensParaEnvioS1210($params) {
        try {
            $sql = <<<SQL
SELECT DISTINCT VM.NRPESSOA, VM.NRPESSOA as NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
  LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = EH.NRESTRUTURAM
                               AND ESOPARAMS.NRORG = EH.NRORG
  /*Movimentacao de saida*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                  AND EHS.NRVINCULOM = VH.NRVINCULOM
  /*Movimentacao de entrada*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8) EHN ON EHN.NRORG = VH.NRORG
                                              AND EHN.NRVINCULOM = VH.NRVINCULOM  
                                              AND EHN.DTINIMOVIMENT >= EHS.DTINIMOVIMENT                                          
                                              AND SUBSTR(EHN.CDCNPJESTRUT,1,8) <> SUBSTR(EHS.CDCNPJESTRUT,1,8)                               
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND EXISTS (
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                )
   AND ((NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N')
        OR (IT.NREVENTOM = 3050 AND ESOPARAMS.IDAPROVACALCRESC = 'S' 
            AND EXISTS(SELECT 1
                         FROM FPA_ITECALCFOLHA ITFEC 
                        WHERE ITFEC.NRORG = VH.NRORG
                          AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                          AND ITFEC.NREVENTOM = 3035
                          AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)
             )
        OR IT.NREVENTOM <> 3050) 
   AND ((NVL(ESOPARAMS.IDAPROVACALCFERIAS, 'N') = 'N')
        OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 2 AND ESOPARAMS.IDAPROVACALCFERIAS = 'S'
            AND EXISTS(SELECT 1
                         FROM FPA_ITECALCFOLHA ITFEC 
                        WHERE ITFEC.NRORG = VH.NRORG
                          AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                          AND ITFEC.NREVENTOM = 3035
                          AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)
             )
        OR CF.NRTIPOMOVIMENT <> 2) 
   AND EHN.DTINIMOVIMENT IS NULL
   AND EHS.DTINIMOVIMENT IS NULL
   AND EH.NRESTRUTURAM = :P_NRESTRUTURAM
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
UNION ALL
/*Vinculos que tiveram movimentacao de saida na competencia e tem remuneracao anterior*/
SELECT DISTINCT VM.NRPESSOA, VM.NRPESSOA AS NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, EM.NMESTRUTURAM, EH.CDCNPJESTRUT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EH ON EH.NRORG = VH.NRORG
                                                                                                  AND EH.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND EXISTS (/*getDadosS1200itensRemun*/
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                )
   AND EH.NRESTRUTURAM = :P_NRESTRUTURAM
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
UNION ALL
/*Vinculos que tiveram movimentacao de entrada e remuneracao na competencia */
SELECT DISTINCT VM.NRPESSOA, VM.NRPESSOA AS NRCHAVE,
       '1' as NRTABELA,
       'I' as IDOPERACAO,
       TRUNC(IT.DTOCORRENCIA,'MONTH') as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
/*Movimentação de entrada*/
 JOIN (SELECT  MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAH EH ON EH.NRORG = MO.NRORG
                                 AND EH.NRESTRUTURAM = MO.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHN ON EHN.NRORG = VH.NRORG
                                                                                                   AND EHN.NRVINCULOM = VH.NRVINCULOM
  /*Movimentacao de saida*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAH EH ON EH.NRORG = MO.NRORG
                                 AND EH.NRESTRUTURAM = MO.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                   AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTMESCOMPETENC
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   --AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC < SYSDATE)
   AND EHN.NRESTRUTURAM = :P_NRESTRUTURAM
   AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
   AND EXISTS (/*getDadosS1200itensRemun*/
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.NREVENTOM NOT IN (3030,3050)
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
               )
SQL;
            $params = array(
                "P_NRORG" => $this->environment->getNrOrgTrab(),
                "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
                "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
                "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                "P_NRPESSOA" => isset($params['NRPESSOA']) ? $params['NRPESSOA'] : null,
            );
            return $this->connection->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1210($params) {
        try {
            $dataHistorico = \HCM\Util\DateUtil::getDataDeString($params['DTMESCOMPETENC'], \HCM\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA, true)->format("d/m/Y");
            
            $dados = $this->getDadosPrincipais($params['NRESTRUTURAM'], $params['NRCHAVE'], $params['NRTABELA'], $dataHistorico, $params['NRTPAMBIENTE']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosPrincipais($nrestruturam, $nrchave, $nrtabela, $dtocorrencia, $nrtpambiente) {
        $sql = <<<SQL
/*getDadosS1210*/
SELECT DISTINCT VM.NRPESSOA CHAVE,
       /*ideEvento*/
       1 as indApuracao,
       TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM') as perApur,
       /*ideEmpregador*/
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END NRINSC,    
       /*ideBenef*/
       REPLACE(REPLACE(PH.NRCPFPESSOA, '.'), '-') AS cpfBenef,  
       /*infoPgto getDadosS1210infoPgto*/
       /*infoIRComplem*/
       '' dtLaudo,
       /*infoIRCR getDadosS1210infoIRCR*/
       /*dedDepen getDadosS1210dedDepen*/
       VM.NRORG, VM.NRPESSOA, PE.NRPARCNEGOCIO, VH.NRESTRUTLEGAL, PAR.NRINSCRICAOPARC, :P_NRTABELA AS NRTABELA, :P_DTOCORRENCIA AS DTOCORRENCIA, :P_NRTPAMBIENTE AS NRTPAMBIENTE, DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMH.IDOPTSIMPLES, 'S', :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR) INIVALIDADEAMB 
  FROM GPE_VINCULOM VM
  /*Dados do Empregado - Vínculo*/
  /*JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM = VM.NRVINCULOM
   AND VH.NRORG      = VM.NRORG
   AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                             WHERE GPE_VINCULOH.DTMESCOMPETENC <= P_DTMESCOMPETENC
                               AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(P_DTMESCOMPETENC),'YEAR'),-12)
                               AND GPE_VINCULOH.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_VINCULOH.NRORG = VM.NRORG)*/
    /*Otimização de Desempenho - João Victor Martins 20/09/2023*/
    JOIN GPE_VINCULOH VH
        ON VH.NRVINCULOM = VM.NRVINCULOM
    AND VH.NRORG      = VM.NRORG
    AND VH.DTMESCOMPETENC = ( SELECT *
                  FROM ( SELECT VH1.DTMESCOMPETENC
                         FROM GPE_VINCULOH VH1
                         WHERE VH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                           AND VH1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                           AND VH1.NRORG      = VM.NRORG
                           AND VH1.NRVINCULOM = VM.NRVINCULOM
                         ORDER BY DTMESCOMPETENC DESC )
                   WHERE ROWNUM = 1 )
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE
    ON PE.NRPESSOA = VM.NRPESSOA
   AND PE.NRORG    = VM.NRORG
  JOIN GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
   AND PH.NRORG    = PE.NRORG
   AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                             WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                               AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                               AND GPE_PESSOAH.NRORG = PE.NRORG)
  /*Calculo*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
  /*Empregador*/
  LEFT JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(PAR.NRINSCRICAOPARC,1,8)
UNION ALL
SELECT DISTINCT VM.NRPESSOA CHAVE,
       /*ideEvento*/
       1 as indApuracao,
       TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM') as perApur,
       /*ideEmpregador*/
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END NRINSC,    
       /*ideBenef*/
       REPLACE(REPLACE(PH.NRCPFPESSOA, '.'), '-') AS cpfBenef,
       /*infoPgto getDadosS1210infoPgto*/
       /*infoIRComplem*/
       '' dtLaudo,
       /*infoIRCR getDadosS1210infoIRCR*/
       /*dedDepen getDadosS1210dedDepen*/
       VM.NRORG, VM.NRPESSOA, PE.NRPARCNEGOCIO, VH.NRESTRUTLEGAL, PAR.NRINSCRICAOPARC, :P_NRTABELA AS NRTABELA, :P_DTOCORRENCIA AS DTOCORRENCIA, :P_NRTPAMBIENTE AS NRTPAMBIENTE, DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMH.IDOPTSIMPLES, 'S', :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR) INIVALIDADEAMB 
  FROM GPE_VINCULOM VM
  /*Dados do Empregado - Vínculo*/
  /*JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM = VM.NRVINCULOM
   AND VH.NRORG      = VM.NRORG
   AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                             WHERE GPE_VINCULOH.DTMESCOMPETENC <= P_DTMESCOMPETENC
                               AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(P_DTMESCOMPETENC),'YEAR'),-12)
                               AND GPE_VINCULOH.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_VINCULOH.NRORG = VM.NRORG)*/
    /*Otimização de Desempenho - João Victor Martins 20/09/2023*/
    JOIN GPE_VINCULOH VH
        ON VH.NRVINCULOM = VM.NRVINCULOM
    AND VH.NRORG      = VM.NRORG
    AND VH.DTMESCOMPETENC = ( SELECT *
                  FROM ( SELECT VH1.DTMESCOMPETENC
                         FROM GPE_VINCULOH VH1
                         WHERE VH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                           AND VH1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                           AND VH1.NRORG      = VM.NRORG
                           AND VH1.NRVINCULOM = VM.NRVINCULOM
                         ORDER BY DTMESCOMPETENC DESC )
                   WHERE ROWNUM = 1 )
  /*Movimentacao de saida*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EH ON EH.NRORG = VH.NRORG
                                                                                                  AND EH.NRVINCULOM = VH.NRVINCULOM
    /*Movimentacao de entrada*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8) EHN ON EHN.NRORG = VH.NRORG
                                              AND EHN.NRVINCULOM = VH.NRVINCULOM  
                                              AND EHN.DTINIMOVIMENT >= EH.DTINIMOVIMENT                                          
                                              AND SUBSTR(EHN.CDCNPJESTRUT,1,8) <> SUBSTR(EH.CDCNPJESTRUT,1,8)
  /*Calculo*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = TRUNC(EH.DTFIMMOVIMENT,'MONTH') 
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE
    ON PE.NRPESSOA = VM.NRPESSOA
   AND PE.NRORG    = VM.NRORG
  JOIN GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
   AND PH.NRORG    = PE.NRORG
   AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                             WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                               AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                               AND GPE_PESSOAH.NRORG = PE.NRORG)
  /*Empregador*/
  LEFT JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(PAR.NRINSCRICAOPARC,1,8)
SQL;
        $params = array(
            "P_NRORG" => $this->environment->getNrOrgTrab(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->environment->getEsoIniValidPeriodProdRest(),
            "P_INIVALIDADEAMBP" => $this->environment->getEsoIniValidPeriodProducao(),
            "P_INIVALIDADEAMBNS" => $this->environment->getEsoIniValidPeriodNacioSimples(),
            "P_NRCHAVE" => $nrchave,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function getDadosS1210infoPgto($params) {
        try {
            $funcionario = $this->getDadosS1210VerificaMovimentacao($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC']);
            if ($funcionario['NRTPMOVTRANSFM'] == '8') {
                $dados = $this->getDadosS1210infoPgtoTransfSaid(
                    $params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA'], $params['NRTPAMBIENTE'], $params['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                );
            } else if ($funcionario['NRTPMOVTRANSFM'] == '9') {
                $dados = $this->getDadosS1210infoPgtoTransfEntr(
                    $params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA'], $params['NRTPAMBIENTE'], $params['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                );
            } else {
                /*Verifica se a pessoa tem mais de um vínculo com a mesma categoria. Ex: 2 vínculos CLT*/
                $vincMesmaCateg = $this->getDadosS1210VerificaVinculosMesmaCategoria($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['DTOCORRENCIA']);
                if ($vincMesmaCateg) {
                    /*Caso tenha mais de um vínculo de mesma categoria, gera o demonstrativo de pagamento com o total de líquido somado dos vínculos*/
                    $dados = $this->getDadosS1210infoPgtoSemTransfSomado(
                        $params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA'], $params['NRTPAMBIENTE'], $params['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                    );
                } else {
                    $dados = $this->getDadosS1210infoPgtoSemTransf(
                        $params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA'], $params['NRTPAMBIENTE'], $params['INIVALIDADEAMB'], $funcionario['NRTPMOVTRANSFM']
                    );
                }
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosS1210VerificaMovimentacao($nrorg, $nrpessoa, $nrinscricaoparc) {
        $sql = <<<SQL
/*getDadosS1210VerificaMovimentacao*/
SELECT VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, MO.NRESTRUTURAM, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.NRTPMOVTRANSFM, MO.DTINIMOVIMENT, MO.DTFIMMOVIMENT
  FROM GPE_VINCULOM VM
  JOIN GPE_MOVIMENTACAO MO ON MO.NRORG = VM.NRORG
                          AND MO.NRVINCULOM = VM.NRVINCULOM
                          AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                          AND MO.NRTIPOTRANSFER = 1
                          AND (MO.NRTPMOVTRANSFM = 8 OR MO.NRTPMOVTRANSFM = 9)
                          AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
   JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                     AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
   LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                     AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                     AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                               WHERE H1.NRORG = EH.NRORG
                                                 AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                 AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  WHERE VM.NRORG = :P_NRORG
    AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
    AND VM.NRPESSOA = :P_NRPESSOA
    AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function getDadosS1210VerificaVinculosMesmaCategoria($nrorg, $nrpessoa, $nrinscricaoparc, $dtocorrencia) {
        $sql = <<<SQL
/*getDadosS1210VerificaVinculosMesmaCategoria*/
SELECT VM.NRTIPOVINCULOM, CE.CDESOCIAL, COUNT(VM.NRVINCULOM) QTDVINCULOS
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND IT.NREVENTOM = 3050))
   AND ((CF.NRTIPOMOVIMENT = 4 AND IT.DTOCORRENCIA >= CF.DTOCORRENCIA) OR CF.NRTIPOMOVIMENT <> 4)
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 GROUP BY VM.NRTIPOVINCULOM, CE.CDESOCIAL, CF.NRCALCULOFOLHA
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_DTOCORRENCIA" => $dtocorrencia,
        );
        
        $categorias = $this->connection->fetchAll($sql, $params);
        
        foreach ($categorias as $vinculo) {
            if ($vinculo['QTDVINCULOS'] > 1) {
                return true;
            }
        }
        
        return false;
    }
    
    public function getDadosS1210infoPgtoTransfEntr($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia, $nrtpambiente, $inivalidadeamb, $nrtpmovtransfm) {
        $sql = <<<SQL
/*getDadosS1210infoPgtoTransfEntr*/
SELECT DISTINCT TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM-DD') dtPgto,
       DECODE(IT.NREVENTOM, 3050, CASE WHEN VM.DTRESCISAOVINC < :P_INIVALIDADEAMB THEN '9' WHEN VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA THEN '1' WHEN TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN '1' ELSE DECODE(VM.NRTIPOVINCULOM,1,'2',DECODE(CE.CDESOCIAL,'721','3','1')) END, CASE WHEN CF.DTOCORRENCIA < TRUNC(TO_DATE(:P_INIVALIDADEAMB),'MM') THEN '9' WHEN TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY') = TO_CHAR(CF.DTOCORRENCIA,'MMYYYY') AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NRTIPOMOVIMENT = 4 THEN '1' WHEN (CALCULORESC.NRCALCULOFOLHA IS NOT NULL OR TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH') = TO_DATE(CF.DTOCORRENCIA)) AND ENVIODT.NRENVIO IS NULL THEN DECODE(VM.NRTIPOVINCULOM,1,'2','3') ELSE DECODE(CF.NRTIPOMOVIMENT,2,'1','1') END) tpPgto,
       DECODE(IT.NREVENTOM,3050,CASE WHEN (VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA AND TO_CHAR(RESC.DTOCORRENCIACALC,'YYYY-MM') <> TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM')) OR TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM') ELSE TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') END, CASE WHEN ENV.NRRECIBO2 IS NOT NULL AND RESC.DTOCORRENCIA IS NULL AND CF.DTOCORRENCIA = FIRST_DAY(VM.DTRESCISAOVINC) AND ENVIODT.NRENVIO IS NULL THEN TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') ELSE TO_CHAR(CF.DTOCORRENCIA, CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN 'YYYY' ELSE 'YYYY-MM' END) END) perRef,
       NVL(IT.IDEDMDEV, VM.NRTIPOVINCULOM||'.'||CE.CDESOCIAL||'.'||CF.NRCALCULOFOLHA) ideDmDev,
       ROUND(DECODE(IT.NREVENTOM,3030,IT.VREVENTOFOLHA,3040,IT.VREVENTOFOLHA,3050,IT.VREVENTOFOLHA,0),2) vrLiq,
       VM.NRORG, VM.NRPESSOA, IT.DTOCORRENCIA, :P_NRTABELA NRTABELA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, :P_NRTPAMBIENTE AS NRTPAMBIENTE, :P_INIVALIDADEAMB INIVALIDADEAMB, DECODE(VM.DTRESCISAOVINC,NULL,NULL,CF.DTOCORRENCIA) DTOCORRECALC,
       :P_NRTPMOVTRANSFM NRTPMOVTRANSFM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Movimentação de entrada*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHN ON EHN.NRORG = VH.NRORG
                                                                                                   AND EHN.NRVINCULOM = VH.NRVINCULOM
                                                                                                   AND SUBSTR(EHN.CDCNPJESTRUT,1,8) = SUBSTR(EH.CDCNPJESTRUT,1,8)
  /*Movimentacao de saida*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                   AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND (EHN.DTINIMOVIMENT IS NOT NULL AND CF.DTOCORRENCIA >= :P_DTOCORRENCIA)
  LEFT JOIN ESO_ENVIOCADASTROS ENV ON ENV.NRORG = VM.NRORG
                                  AND ENV.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                  AND ENV.NRCHAVE = VM.NRVINCULOM
                                  AND ENV.NRTPAMBIENTE = :P_NRTPAMBIENTE
                                  AND ENV.IDATIVO = 'S'
                                  AND (ENV.IDSTATUS = 'C' OR ENV.IDSTATUS = 'A')
                                  AND ENV.NRENVIOEXCL IS NULL
                                  AND ENV.NREVENTO IN (SELECT EVE.NREVENTO FROM ESO_EVENTO EVE
                                                        WHERE EVE.NREVENTO = ENV.NREVENTO
                                                          AND EVE.NMEVENTO = DECODE(VM.NRTIPOVINCULOM,1,'S-2299','S-2399'))
  /*Verifica se o 13 foi enviado no S-1200 ou no S-2299*/
  LEFT JOIN (SELECT EC.*
               FROM ESO_ENVIOCADASTROS EC
               LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                  AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                  AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSCRICAOPARC, 1,8)
                                  AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                              FROM ESTRUTURAH ESHH
                                                             WHERE ESHH.NRORG = ESH.NRORG
                                                               AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                               AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE EC.IDSTATUS IN ('C', 'A')
                AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                AND EC.NRTABELA = 4
                AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                AND EC.NRENVIOEXCL IS NULL
                AND ESH.NRESTRUTURAM IS NOT NULL
                AND EC.IDATIVO = 'S'
                AND EC.NREVENTO IN (SELECT SE.NREVENTO
                                      FROM ESO_EVENTO SE
                                     WHERE SE.NMEVENTO = 'S-1200')) ENVIODT ON ENVIODT.NRCHAVE = VM.NRPESSOA 
                                                                           AND ENVIODT.NRORG = VM.NRORG
                                                                           AND ENVIODT.NRTABELA  = CF.NRTIPOMOVIMENT
                                                                           AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'
                                                                           AND CF.NROCORRECAL = 1                      
  /*Busca rescisão anterior em caso de complementar*/
  LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, MAX(CFC.DTOCORRENCIA) DTOCORRENCIACALC
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
                AND TRUNC(ITC.DTOCORRENCIA,'MONTH') < :P_DTOCORRENCIA
              GROUP BY ITC.NRORG, ITC.NRVINCULOM) RESC ON RESC.NRORG = IT.NRORG
                                                      AND RESC.NRVINCULOM = IT.NRVINCULOM
                                                      AND RESC.DTOCORRENCIACALC < CF.DTOCORRENCIA
   /*Busca cálculo para verificar se é um adiantamento com rescisão*/
   LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, CFC.NRCALCULOFOLHA
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
              GROUP BY ITC.NRORG, ITC.NRVINCULOM, ITC.DTOCORRENCIA, CFC.NRCALCULOFOLHA) CALCULORESC ON CALCULORESC.NRORG = IT.NRORG
                                                                                                   AND CALCULORESC.NRVINCULOM = IT.NRVINCULOM
                                                                                                   AND TRUNC(CALCULORESC.DTOCORRENCIA,'MONTH') = TRUNC(CF.DTOCORRENCIA,'MONTH')
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_NRTPMOVTRANSFM" => $nrtpmovtransfm,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210infoPgtoTransfSaid($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia, $nrtpambiente, $inivalidadeamb, $nrtpmovtransfm) {
        $sql = <<<SQL
/*getDadosS1210infoPgtoTransfSaid*/
SELECT DISTINCT TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM-DD') dtPgto,
       DECODE(IT.NREVENTOM, 3050, CASE WHEN VM.DTRESCISAOVINC < :P_INIVALIDADEAMB THEN '9' WHEN VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA THEN '1' WHEN TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN '1' ELSE DECODE(VM.NRTIPOVINCULOM,1,'2',DECODE(CE.CDESOCIAL,'721','3','1')) END, CASE WHEN CF.DTOCORRENCIA < TRUNC(TO_DATE(:P_INIVALIDADEAMB),'MM') THEN '9' WHEN TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY') = TO_CHAR(CF.DTOCORRENCIA,'MMYYYY') AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NRTIPOMOVIMENT = 4 THEN '1' WHEN (CALCULORESC.NRCALCULOFOLHA IS NOT NULL OR TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH') = TO_DATE(CF.DTOCORRENCIA)) AND ENVIODT.NRENVIO IS NULL THEN DECODE(VM.NRTIPOVINCULOM,1,'2','3') ELSE DECODE(CF.NRTIPOMOVIMENT,2,'1','1') END) tpPgto,
       DECODE(IT.NREVENTOM,3050,CASE WHEN (VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA AND TO_CHAR(RESC.DTOCORRENCIACALC,'YYYY-MM') <> TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM')) OR TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM') ELSE TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') END, CASE WHEN ENV.NRRECIBO2 IS NOT NULL AND RESC.DTOCORRENCIA IS NULL AND CF.DTOCORRENCIA = FIRST_DAY(VM.DTRESCISAOVINC) AND ENVIODT.NRENVIO IS NULL THEN TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') ELSE TO_CHAR(CF.DTOCORRENCIA, CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN 'YYYY' ELSE 'YYYY-MM' END) END) perRef,
       NVL(IT.IDEDMDEV, VM.NRTIPOVINCULOM||'.'||CE.CDESOCIAL||'.'||CF.NRCALCULOFOLHA) ideDmDev,
       ROUND(DECODE(IT.NREVENTOM,3030,IT.VREVENTOFOLHA,3040,IT.VREVENTOFOLHA,3050,IT.VREVENTOFOLHA,0),2) vrLiq,
       VM.NRORG, VM.NRPESSOA, IT.DTOCORRENCIA, :P_NRTABELA NRTABELA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, :P_NRTPAMBIENTE AS NRTPAMBIENTE, :P_INIVALIDADEAMB INIVALIDADEAMB, DECODE(VM.DTRESCISAOVINC,NULL,NULL,CF.DTOCORRENCIA) DTOCORRECALC,
       :P_NRTPMOVTRANSFM NRTPMOVTRANSFM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Movimentacao de saida*/
  JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                  AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = TRUNC(EHS.DTFIMMOVIMENT,'MONTH')
  LEFT JOIN ESO_ENVIOCADASTROS ENV ON ENV.NRORG = VM.NRORG
                                  AND ENV.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                  AND ENV.NRCHAVE = VM.NRVINCULOM
                                  AND ENV.NRTPAMBIENTE = :P_NRTPAMBIENTE
                                  AND ENV.IDATIVO = 'S'
                                  AND (ENV.IDSTATUS = 'C' OR ENV.IDSTATUS = 'A')
                                  AND ENV.NRENVIOEXCL IS NULL
                                  AND ENV.NREVENTO IN (SELECT EVE.NREVENTO FROM ESO_EVENTO EVE
                                                        WHERE EVE.NREVENTO = ENV.NREVENTO
                                                          AND EVE.NMEVENTO = DECODE(VM.NRTIPOVINCULOM,1,'S-2299','S-2399'))
  /*Verifica se o 13 foi enviado no S-1200 ou no S-2299*/
  LEFT JOIN (SELECT EC.*
               FROM ESO_ENVIOCADASTROS EC
               LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                  AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                  AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSCRICAOPARC, 1,8)
                                  AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                              FROM ESTRUTURAH ESHH
                                                             WHERE ESHH.NRORG = ESH.NRORG
                                                               AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                               AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE EC.IDSTATUS IN ('C', 'A')
                AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                AND EC.NRTABELA = 4
                AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                AND EC.NRENVIOEXCL IS NULL
                AND ESH.NRESTRUTURAM IS NOT NULL
                AND EC.IDATIVO = 'S'
                AND EC.NREVENTO IN (SELECT SE.NREVENTO
                                      FROM ESO_EVENTO SE
                                     WHERE SE.NMEVENTO = 'S-1200')) ENVIODT ON ENVIODT.NRCHAVE = VM.NRPESSOA 
                                                                           AND ENVIODT.NRORG = VM.NRORG
                                                                           AND ENVIODT.NRTABELA  = CF.NRTIPOMOVIMENT
                                                                           AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'
                                                                           AND CF.NROCORRECAL = 1                     
  /*Busca rescisão anterior em caso de complementar*/
  LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, MAX(CFC.DTOCORRENCIA) DTOCORRENCIACALC
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
                AND TRUNC(ITC.DTOCORRENCIA,'MONTH') < :P_DTOCORRENCIA
              GROUP BY ITC.NRORG, ITC.NRVINCULOM) RESC ON RESC.NRORG = IT.NRORG
                                                      AND RESC.NRVINCULOM = IT.NRVINCULOM
                                                      AND RESC.DTOCORRENCIACALC < CF.DTOCORRENCIA
   /*Busca cálculo para verificar se é um adiantamento com rescisão*/
   LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, CFC.NRCALCULOFOLHA
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
              GROUP BY ITC.NRORG, ITC.NRVINCULOM, ITC.DTOCORRENCIA, CFC.NRCALCULOFOLHA) CALCULORESC ON CALCULORESC.NRORG = IT.NRORG
                                                                                                   AND CALCULORESC.NRVINCULOM = IT.NRVINCULOM
                                                                                                   AND TRUNC(CALCULORESC.DTOCORRENCIA,'MONTH') = TRUNC(CF.DTOCORRENCIA,'MONTH')
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EHS.CDCNPJESTRUT,1,8) <> SUBSTR(EH.CDCNPJESTRUT,1,8)
   AND SUBSTR(EHS.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_NRTPMOVTRANSFM" => $nrtpmovtransfm,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210infoPgtoSemTransf($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia, $nrtpambiente, $inivalidadeamb, $nrtpmovtransfm) {
        $sql = <<<SQL
/*getDadosS1210infoPgtoSemTransf*/
SELECT DISTINCT TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM-DD') dtPgto,
       DECODE(IT.NREVENTOM, 3050, 
            CASE 
                WHEN VM.DTRESCISAOVINC < :P_INIVALIDADEAMB THEN '9' 
                WHEN VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA THEN '1' 
                WHEN TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN '1' 
                ELSE DECODE(VM.NRTIPOVINCULOM,1,'2',DECODE(CE.CDESOCIAL,'721','3','1')) 
            END, 
            CASE 
                WHEN CF.DTOCORRENCIA < TRUNC(TO_DATE(:P_INIVALIDADEAMB),'MM') THEN '9' 
                WHEN TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY') = TO_CHAR(CF.DTOCORRENCIA,'MMYYYY') AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NRTIPOMOVIMENT = 4 THEN '1' 
                WHEN TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH') < CF.DTOCORRENCIA AND CF.NRTIPOMOVIMENT = 19 THEN '1' /*PLR PARA RESCINDIDOS*/
                WHEN (CALCULORESC.NRCALCULOFOLHA IS NOT NULL OR TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH') = TO_DATE(CF.DTOCORRENCIA)) AND ENVIODT.NRENVIO IS NULL THEN DECODE(VM.NRTIPOVINCULOM,1,'2','3') 
                ELSE DECODE(CF.NRTIPOMOVIMENT,2,'1','1') 
            END) tpPgto,
       DECODE(IT.NREVENTOM,3050,CASE WHEN (VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA AND TO_CHAR(RESC.DTOCORRENCIACALC,'YYYY-MM') <> TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM')) OR TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM') ELSE TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') END, CASE WHEN ENV.NRRECIBO2 IS NOT NULL AND RESC.DTOCORRENCIA IS NULL AND CF.DTOCORRENCIA = FIRST_DAY(VM.DTRESCISAOVINC) AND ENVIODT.NRENVIO IS NULL THEN TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') ELSE TO_CHAR(CF.DTOCORRENCIA, CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN 'YYYY' ELSE 'YYYY-MM' END) END) perRef,
       NVL(IT.IDEDMDEV, VM.NRTIPOVINCULOM||'.'||CE.CDESOCIAL||'.'||CF.NRCALCULOFOLHA) ideDmDev,
       ROUND(DECODE(IT.NREVENTOM,3030,IT.VREVENTOFOLHA,3040,IT.VREVENTOFOLHA,3050,IT.VREVENTOFOLHA,0),2) vrLiq,
       VM.NRORG, VM.NRPESSOA, IT.DTOCORRENCIA, :P_NRTABELA NRTABELA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, :P_NRTPAMBIENTE AS NRTPAMBIENTE, :P_INIVALIDADEAMB INIVALIDADEAMB, DECODE(VM.DTRESCISAOVINC,NULL,NULL,CF.DTOCORRENCIA) DTOCORRECALC,
       :P_NRTPMOVTRANSFM NRTPMOVTRANSFM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Movimentação de entrada*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHN ON EHN.NRORG = VH.NRORG
                                                                                                   AND EHN.NRVINCULOM = VH.NRVINCULOM
  /*Movimentacao de saida*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                   AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
  LEFT JOIN ESO_ENVIOCADASTROS ENV ON ENV.NRORG = VM.NRORG
                                  AND ENV.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                  AND ENV.NRCHAVE = VM.NRVINCULOM
                                  AND ENV.NRTPAMBIENTE = :P_NRTPAMBIENTE
                                  AND ENV.IDATIVO = 'S'
                                  AND (ENV.IDSTATUS = 'C' OR ENV.IDSTATUS = 'A')
                                  AND ENV.NRENVIOEXCL IS NULL
                                  AND ENV.NREVENTO IN (SELECT EVE.NREVENTO FROM ESO_EVENTO EVE
                                                        WHERE EVE.NREVENTO = ENV.NREVENTO
                                                          AND EVE.NMEVENTO = DECODE(VM.NRTIPOVINCULOM,1,'S-2299','S-2399'))
  /*Verifica se o 13 foi enviado no S-1200 ou no S-2299*/
  LEFT JOIN (SELECT EC.*
               FROM ESO_ENVIOCADASTROS EC
               LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                  AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                  AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSCRICAOPARC, 1,8)
                                  AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                              FROM ESTRUTURAH ESHH
                                                             WHERE ESHH.NRORG = ESH.NRORG
                                                               AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                               AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE EC.IDSTATUS IN ('C', 'A')
                AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                AND EC.NRTABELA = 4
                AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                AND EC.NRENVIOEXCL IS NULL
                AND ESH.NRESTRUTURAM IS NOT NULL
                AND EC.IDATIVO = 'S'
                AND EC.NREVENTO IN (SELECT SE.NREVENTO
                                      FROM ESO_EVENTO SE
                                     WHERE SE.NMEVENTO = 'S-1200')) ENVIODT ON ENVIODT.NRCHAVE = VM.NRPESSOA 
                                                                           AND ENVIODT.NRORG = VM.NRORG
                                                                           AND ENVIODT.NRTABELA  = CF.NRTIPOMOVIMENT
                                                                           AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'
                                                                           AND CF.NROCORRECAL = 1
  /*Busca rescisão anterior em caso de complementar*/
  LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, MAX(CFC.DTOCORRENCIA) DTOCORRENCIACALC
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
                AND TRUNC(ITC.DTOCORRENCIA,'MONTH') < :P_DTOCORRENCIA
              GROUP BY ITC.NRORG, ITC.NRVINCULOM) RESC ON RESC.NRORG = IT.NRORG
                                                      AND RESC.NRVINCULOM = IT.NRVINCULOM
                                                      AND RESC.DTOCORRENCIACALC < CF.DTOCORRENCIA
   /*Busca cálculo para verificar se é um adiantamento com rescisão*/
   LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, CFC.NRCALCULOFOLHA
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
              GROUP BY ITC.NRORG, ITC.NRVINCULOM, ITC.DTOCORRENCIA, CFC.NRCALCULOFOLHA) CALCULORESC ON CALCULORESC.NRORG = IT.NRORG
                                                                                                   AND CALCULORESC.NRVINCULOM = IT.NRVINCULOM
                                                                                                   AND TRUNC(CALCULORESC.DTOCORRENCIA,'MONTH') = TRUNC(CF.DTOCORRENCIA,'MONTH')
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND ((CF.NRTIPOMOVIMENT = 4 AND IT.DTOCORRENCIA >= CF.DTOCORRENCIA) OR CF.NRTIPOMOVIMENT <> 4)
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EHN.DTINIMOVIMENT IS NULL AND EHS.DTINIMOVIMENT IS NULL
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_NRTPMOVTRANSFM" => $nrtpmovtransfm,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210infoPgtoSemTransfSomado($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia, $nrtpambiente, $inivalidadeamb, $nrtpmovtransfm) {
        $sql = <<<SQL
/*getDadosS1210infoPgtoSemTransfSomado*/
SELECT TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM-DD') dtPgto,
       DECODE(IT.NREVENTOM, 3050, 
              CASE 
                WHEN VM.DTRESCISAOVINC < TO_DATE('01/05/2017') THEN '9' 
                WHEN VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA THEN '1' 
                WHEN TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN '1' 
                ELSE DECODE(VM.NRTIPOVINCULOM,1,'2',DECODE(CE.CDESOCIAL,'721','3','1')) 
              END, 
              CASE 
                WHEN CF.DTOCORRENCIA < TRUNC(TO_DATE(:P_INIVALIDADEAMB),'MM') THEN '9' 
                WHEN TO_CHAR(VM.DTRESCISAOVINC,'MMYYYY') = TO_CHAR(CF.DTOCORRENCIA,'MMYYYY') AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NRTIPOMOVIMENT = 4 THEN '1'
                WHEN (CALCULORESC.NRCALCULOFOLHA IS NOT NULL OR TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH') = TO_DATE(CF.DTOCORRENCIA)) AND ENVIODT.NRENVIO IS NULL THEN DECODE(VM.NRTIPOVINCULOM,1,'2','3') 
                ELSE DECODE(CF.NRTIPOMOVIMENT,2,'1','1') 
              END) tpPgto,
       DECODE(IT.NREVENTOM,3050,CASE WHEN (VM.DTRESCISAOVINC <= RESC.DTOCORRENCIA AND TO_CHAR(RESC.DTOCORRENCIACALC,'YYYY-MM') <> TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM')) OR TRUNC(VM.DTRESCISAOVINC,'MM') < CF.DTOCORRENCIA THEN TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM') ELSE TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') END, CASE WHEN ENV.NRRECIBO2 IS NOT NULL AND RESC.DTOCORRENCIA IS NULL AND CF.DTOCORRENCIA = FIRST_DAY(VM.DTRESCISAOVINC) AND ENVIODT.NRENVIO IS NULL THEN TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM') ELSE TO_CHAR(CF.DTOCORRENCIA, CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN 'YYYY' ELSE 'YYYY-MM' END) END) perRef,
       NVL(IT.IDEDMDEV, VM.NRTIPOVINCULOM||'.'||CE.CDESOCIAL||'.'||CF.NRCALCULOFOLHA) ideDmDev,
       SUM(ROUND(DECODE(IT.NREVENTOM,3030,IT.VREVENTOFOLHA,3040,IT.VREVENTOFOLHA,3050,IT.VREVENTOFOLHA,0),2)) vrLiq,
       VM.NRORG, VM.NRPESSOA, IT.DTOCORRENCIA, :P_NRTABELA NRTABELA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, :P_NRTPAMBIENTE AS NRTPAMBIENTE, :P_INIVALIDADEAMB INIVALIDADEAMB, DECODE(VM.DTRESCISAOVINC,NULL,NULL,CF.DTOCORRENCIA) DTOCORRECALC,
       :P_NRTPMOVTRANSFM NRTPMOVTRANSFM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Movimentação de entrada*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 8
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHN ON EHN.NRORG = VH.NRORG
                                                                                                   AND EHN.NRVINCULOM = VH.NRVINCULOM
  /*Movimentacao de saida*/
  LEFT JOIN (SELECT MO.NRORG, MO.NRESTRUTURAM, MO.NRVINCULOM, MO.DTFIMMOVIMENT, EM.NMESTRUTURAM, EH.CDCNPJESTRUT, MO.DTINIMOVIMENT
               FROM GPE_MOVIMENTACAO MO
               JOIN ESTRUTURAM EM ON EM.NRORG = MO.NRORG
                                 AND EM.NRESTRUTURAM = MO.NRESTRUTURAM
               LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                                 AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                           WHERE H1.NRORG = EH.NRORG
                                                             AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE MO.NRORG = :P_NRORG
                AND MO.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
                AND MO.NRTIPOTRANSFER = 1
                AND MO.NRTPMOVTRANSFM = 9
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) <> SUBSTR(:P_NRINSCRICAOPARC,1,8)
                AND MO.DTINIMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)) EHS ON EHS.NRORG = VH.NRORG
                                                                                                   AND EHS.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
  LEFT JOIN ESO_ENVIOCADASTROS ENV ON ENV.NRORG = VM.NRORG
                                  AND ENV.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                  AND ENV.NRCHAVE = VM.NRVINCULOM
                                  AND ENV.NRTPAMBIENTE = :P_NRTPAMBIENTE
                                  AND ENV.IDATIVO = 'S'
                                  AND (ENV.IDSTATUS = 'C' OR ENV.IDSTATUS = 'A')
                                  AND ENV.NRENVIOEXCL IS NULL
                                  AND ENV.NREVENTO IN (SELECT EVE.NREVENTO FROM ESO_EVENTO EVE
                                                        WHERE EVE.NREVENTO = ENV.NREVENTO
                                                          AND EVE.NMEVENTO = DECODE(VM.NRTIPOVINCULOM,1,'S-2299','S-2399'))
  /*Verifica se o 13 foi enviado no S-1200 ou no S-2299*/
  LEFT JOIN (SELECT EC.*
               FROM ESO_ENVIOCADASTROS EC
               LEFT JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                  AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                  AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSCRICAOPARC, 1,8)
                                  AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                              FROM ESTRUTURAH ESHH
                                                             WHERE ESHH.NRORG = ESH.NRORG
                                                               AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                               AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
              WHERE EC.IDSTATUS IN ('C', 'A')
                AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                AND EC.NRTABELA = 4
                AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                AND EC.NRENVIOEXCL IS NULL
                AND ESH.NRESTRUTURAM IS NOT NULL
                AND EC.IDATIVO = 'S'
                AND EC.NREVENTO IN (SELECT SE.NREVENTO
                                      FROM ESO_EVENTO SE
                                     WHERE SE.NMEVENTO = 'S-1200')) ENVIODT ON ENVIODT.NRCHAVE = VM.NRPESSOA 
                                                                           AND ENVIODT.NRORG = VM.NRORG
                                                                           AND ENVIODT.NRTABELA  = CF.NRTIPOMOVIMENT
                                                                           AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'
                                                                           AND CF.NROCORRECAL = 1
  /*Busca rescisão anterior em caso de complementar*/
  LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, MAX(CFC.DTOCORRENCIA) DTOCORRENCIACALC
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
                AND TRUNC(ITC.DTOCORRENCIA,'MONTH') < :P_DTOCORRENCIA
              GROUP BY ITC.NRORG, ITC.NRVINCULOM) RESC ON RESC.NRORG = IT.NRORG
                                                      AND RESC.NRVINCULOM = IT.NRVINCULOM
                                                      AND RESC.DTOCORRENCIACALC < CF.DTOCORRENCIA
   /*Busca cálculo para verificar se é um adiantamento com rescisão*/
   LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, MAX(ITC.DTOCORRENCIA) DTOCORRENCIA, CFC.NRCALCULOFOLHA
               FROM FPA_ITECALCFOLHA ITC
               JOIN FPA_CALCULOFOLHA CFC ON CFC.NRORG = ITC.NRORG
                                        AND CFC.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                        AND CFC.NRTIPOMOVIMENT = 1
                                        AND CFC.NRTPMODALIDCAL = 1
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NREVENTOM = 3050
              GROUP BY ITC.NRORG, ITC.NRVINCULOM, ITC.DTOCORRENCIA, CFC.NRCALCULOFOLHA) CALCULORESC ON CALCULORESC.NRORG = IT.NRORG
                                                                                                   AND CALCULORESC.NRVINCULOM = IT.NRVINCULOM
                                                                                                   AND TRUNC(CALCULORESC.DTOCORRENCIA,'MONTH') = TRUNC(CF.DTOCORRENCIA,'MONTH')
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND ((CF.NRTIPOMOVIMENT = 4 AND IT.DTOCORRENCIA >= CF.DTOCORRENCIA) OR CF.NRTIPOMOVIMENT <> 4)
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EHN.DTINIMOVIMENT IS NULL AND EHS.DTINIMOVIMENT IS NULL
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 GROUP BY TO_CHAR(IT.DTOCORRENCIA, 'YYYY-MM-DD'),
          IT.NREVENTOM,
          VM.DTRESCISAOVINC,
          TO_DATE('01/05/2017'),
          RESC.DTOCORRENCIA,
          TRUNC(VM.DTRESCISAOVINC,'MM'),
          CF.DTOCORRENCIA,
          VM.NRTIPOVINCULOM, CE.CDESOCIAL,
          TRUNC(TO_DATE(:P_INIVALIDADEAMB),'MM'),
          CALCULORESC.NRCALCULOFOLHA,
          TRUNC(TO_DATE(VM.DTRESCISAOVINC),'MONTH'),
          TO_DATE(CF.DTOCORRENCIA),
          ENVIODT.NRENVIO,
          TO_CHAR(RESC.DTOCORRENCIACALC,'YYYY-MM'),
          TO_CHAR(CF.DTOCORRENCIA,'YYYY-MM'),
          ENV.NRRECIBO2,
          FIRST_DAY(VM.DTRESCISAOVINC),
          CF.NRTIPOMOVIMENT,
          CF.NROCORRECAL,
          TO_CHAR(CF.DTOCORRENCIA,'MM'),
          TO_DATE('01/06/2022'),
          TO_CHAR(CF.NRCALCULOFOLHA),
          CF.NRCALCULOFOLHA,
          IT.IDEDMDEV,
          VM.NRORG, VM.NRPESSOA, IT.DTOCORRENCIA, :P_NRTABELA, :P_NRINSCRICAOPARC, :P_NRTPAMBIENTE, :P_INIVALIDADEAMB, DECODE(VM.DTRESCISAOVINC,NULL,NULL,CF.DTOCORRENCIA), :P_NRTPMOVTRANSFM
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->environment->getTipoEstruturaLegalOrg(),
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_NRTPMOVTRANSFM" => $nrtpmovtransfm,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210infoIRCR($params) {
        $sql = <<<SQL
/*getDadosS1210infoIRCR*/
SELECT CASE
        WHEN CF.NRTIPOMOVIMENT = 19 THEN '356201'
        WHEN VM.NRTIPOVINCULOM = 1 THEN '056107'
        WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN '058806'
       END tpCR,
       VM.NRORG, VM.NRPESSOA,
       LISTAGG(CF.NRCALCULOFOLHA,',') WITHIN GROUP (ORDER BY CF.NRCALCULOFOLHA) NRCALCULOFOLHALIST,
       LISTAGG(DISTINCT VM.NRVINCULOM,',') WITHIN GROUP (ORDER BY VM.NRVINCULOM) NRVINCULOMLIST
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Categoria do Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND ((CF.NRTIPOMOVIMENT = 4 AND IT.DTOCORRENCIA >= CF.DTOCORRENCIA) OR CF.NRTIPOMOVIMENT <> 4)
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
 GROUP BY CASE
        WHEN CF.NRTIPOMOVIMENT = 19 THEN '356201'
        WHEN VM.NRTIPOVINCULOM = 1 THEN '056107'
        WHEN VM.NRTIPOVINCULOM IN (2,3,10) THEN '058806'
       END,
       VM.NRORG, VM.NRPESSOA
SQL;
        $params = array(
            "P_NRORG" => $params['NRORG'],
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRPESSOA" => $params['NRPESSOA'],
            "P_NRINSCRICAOPARC" => $params['NRINSCRICAOPARC'],
            "P_DTOCORRENCIA" => $params['DTOCORRENCIA'],
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210dedDepen($params) {
        $sql = <<<SQL
/*getDadosS1210dedDepen*/
SELECT CASE
        WHEN CF.NRTIPOMOVIMENT = 1 THEN '11'
        WHEN CF.NRTIPOMOVIMENT = 4 THEN '12'
        WHEN CF.NRTIPOMOVIMENT = 2 THEN '13'
       END tpRend,
       LPAD(NVL(REPLACE(REPLACE(PH.NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0') cpfDep,
       SUM(DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * IT.VREVENTOFOLHA, IT.VREVENTOFOLHA))/IT.VRREFFOLHA) vlrDedDep
  FROM FPA_ITECALCFOLHA IT
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                          AND CF.NRTPMODALIDCAL = 1
  /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
  JOIN FPA_GRPITEM GIT ON (GIT.NRORG = :P_NRORG OR GIT.NRORG = :P_NRORG_PADRAO)
                      AND GIT.NRGRPINCIDE  = :P_NRGRUPOINCIDEN
                      AND GIT.NMITEM IN ('RTDP','RTDP-13S')
  JOIN FPA_INCIDEVENTO IEV ON ( IEV.NRORG = IT.NRORG OR IEV.NRORG = :P_NRORG_PADRAO )
                          AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
  JOIN FPA_DEPVINCULO DP ON DP.NRORG = IT.NRORG
                        AND DP.NRVINCULOM = IT.NRVINCULOM
                        AND DP.NRTIPODEPENDE = 2/*IRRF*/
  JOIN GPE_PESSOA PE ON PE.NRORG = DP.NRORG
                    AND PE.NRPESSOA = DP.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                FROM (SELECT H1.DTMESCOMPETENC FROM GPE_PESSOAH H1
                                                       WHERE H1.NRORG = PH.NRORG
                                                         AND H1.NRPESSOA = PH.NRPESSOA
                                                         AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       ORDER BY H1.DTMESCOMPETENC DESC)
                                               WHERE ROWNUM =1)
 WHERE IT.NRORG = :P_NRORG
   AND INSTR(','||:P_NRVINCULOMLIST||',',','||IT.NRVINCULOM||',') > 0
   AND IT.NREVENTOM = IEV.NREVENTOM
   AND (CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTDP-13S', 4))
GROUP BY CASE
        WHEN CF.NRTIPOMOVIMENT = 1 THEN '11'
        WHEN CF.NRTIPOMOVIMENT = 4 THEN '12'
        WHEN CF.NRTIPOMOVIMENT = 2 THEN '13'
       END,
       PH.NRCPFPESSOA
SQL;
        $params = array(
            "P_NRORG" => $params['NRORG'],
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $params['NRCALCULOFOLHALIST'],
            "P_NRVINCULOMLIST" => $params['NRVINCULOMLIST'],
            "P_NRGRUPOINCIDEN" => 10, /*GRUPO INCIDENCIA DIRF*/
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210penAlim($params) {
        $sql = <<<SQL
/*getDadosS1210penAlim*/
SELECT CASE
        WHEN CF.NRTIPOMOVIMENT = 1 THEN '11'
        WHEN CF.NRTIPOMOVIMENT = 4 THEN '12'
        WHEN CF.NRTIPOMOVIMENT = 2 THEN '13'
        WHEN CF.NRTIPOMOVIMENT = 19 THEN '14'
        /*WHEN  THEN '18'*/
        /*WHEN  THEN '79'*/
       END tpRend,
       LPAD(NVL(REPLACE(REPLACE(PH.NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0') cpfDep,
       SUM(DECODE(IEV.IDINCIDEVENTO, 'N', 0, DECODE(IEV.IDINCIDEVENTO, '-', -1 * IT.VREVENTOFOLHA, IT.VREVENTOFOLHA))/IT.VRREFFOLHA) vlrDedDep
  FROM FPA_ITECALCFOLHA IT
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                          AND CF.NRTPMODALIDCAL = 1
  /*Grupo de incidência da DIRF, Itens de Grupo e suas Incidências de eventos e os Itens de Cálculo*/
  JOIN FPA_GRPITEM GIT ON (GIT.NRORG = :P_NRORG OR GIT.NRORG = :P_NRORG_PADRAO)
                      AND GIT.NRGRPINCIDE  = :P_NRGRUPOINCIDEN
                      AND GIT.NMITEM IN ('RTDP','RTDP-13S')
  JOIN FPA_INCIDEVENTO IEV ON ( IEV.NRORG = IT.NRORG OR IEV.NRORG = :P_NRORG_PADRAO )
                          AND IEV.NRTIPOINCIDE = GIT.NRTIPOINCIDE
  JOIN FPA_DEPVINCULO DP ON DP.NRORG = IT.NRORG
                        AND DP.NRVINCULOM = IT.NRVINCULOM
                        AND DP.NRTIPODEPENDE = 3/*PENSAO*/
  JOIN GPE_PESSOA PE ON PE.NRORG = DP.NRORG
                    AND PE.NRPESSOA = DP.NRPESSOA
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                FROM (SELECT H1.DTMESCOMPETENC FROM GPE_PESSOAH H1
                                                       WHERE H1.NRORG = PH.NRORG
                                                         AND H1.NRPESSOA = PH.NRPESSOA
                                                         AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       ORDER BY H1.DTMESCOMPETENC DESC)
                                               WHERE ROWNUM =1)
 WHERE IT.NRORG = :P_NRORG
   AND INSTR(','||:P_NRVINCULOMLIST||',',','||IT.NRVINCULOM||',') > 0
   AND IT.NREVENTOM = IEV.NREVENTOM
   AND (CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 1)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 2)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA-13S', 4)
        OR CF.NRTIPOMOVIMENT = DECODE(GIT.NMITEM, 'RTPA', 19))
GROUP BY CASE
        WHEN CF.NRTIPOMOVIMENT = 1 THEN '11'
        WHEN CF.NRTIPOMOVIMENT = 4 THEN '12'
        WHEN CF.NRTIPOMOVIMENT = 2 THEN '13'
        WHEN CF.NRTIPOMOVIMENT = 19 THEN '14'
        /*WHEN  THEN '18'*/
        /*WHEN  THEN '79'*/
       END,
       PH.NRCPFPESSOA
SQL;
        $params = array(
            "P_NRORG" => $params['NRORG'],
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $params['NRCALCULOFOLHALIST'],
            "P_NRVINCULOMLIST" => $params['NRVINCULOMLIST'],
            "P_NRGRUPOINCIDEN" => 10, /*GRUPO INCIDENCIA DIRF*/
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210planSaude($params) {
        try {
            $dados = array();
            $listas = $this->getListaCalculoVinculo($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['DTOCORRENCIA']);
            if ($listas) {
                $apurabeneficio = $this->verificaApuraBeneficio($listas['NRORG'], $listas['NRVINCULOMLIST']);
                if ($apurabeneficio) {
                    $dados = $this->getDadosPlanSaudeApuraBenef($listas['NRORG'], $listas['NRCALCULOFOLHALIST'], $listas['NRVINCULOMLIST']);
                } else {
                    $dados = $this->getDadosPlanSaudeVincEvento($listas['NRORG'], $listas['NRCALCULOFOLHALIST'], $listas['NRVINCULOMLIST']);
                }
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getListaCalculoVinculo($nrorg, $nrpessoa, $nrinscricaoparc, $dtocorrencia) {
        $sql = <<<SQL
/*getDadosS1210planSaude-getListaCalculoVinculo*/
SELECT VM.NRORG, VM.NRPESSOA,
       LISTAGG(CF.NRCALCULOFOLHA,',') WITHIN GROUP (ORDER BY CF.NRCALCULOFOLHA) NRCALCULOFOLHALIST,
       LISTAGG(DISTINCT VM.NRVINCULOM,',') WITHIN GROUP (ORDER BY VM.NRVINCULOM) NRVINCULOMLIST
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = ( SELECT *
                                                  FROM ( SELECT H1.DTMESCOMPETENC
                                                         FROM GPE_VINCULOH H1
                                                         WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND H1.NRORG      = VH.NRORG
                                                           AND H1.NRVINCULOM = VH.NRVINCULOM
                                                         ORDER BY DTMESCOMPETENC DESC )
                                                   WHERE ROWNUM = 1 )
  /*Categoria do Trabalhador*/
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = ( SELECT *
                                                  FROM ( SELECT H1.DTMESCOMPETENC
                                                         FROM ESTRUTURAH H1
                                                         WHERE H1.NRORG = EH.NRORG
                                                           AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                           AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                         ORDER BY DTMESCOMPETENC DESC )
                                                   WHERE ROWNUM = 1 )
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
                          AND TRUNC(IT.DTOCORRENCIA,'MONTH') = :P_DTOCORRENCIA
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR 
        (VM.DTRESCISAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) AND (IT.NREVENTOM = 3050 OR (IT.NREVENTOM = 3030 AND CF.NRTIPOMOVIMENT = 19))))
   AND ((CF.NRTIPOMOVIMENT = 4 AND IT.DTOCORRENCIA >= CF.DTOCORRENCIA) OR CF.NRTIPOMOVIMENT <> 4)
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND EXISTS(SELECT 1 
                FROM FPA_ITECALCFOLHA ITC
                JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                                   AND (EH.NRORG = ITC.NRORG OR EH.NRORG = :P_NRORG_PADRAO)
                                   AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                              FROM FPA_EVENTOH EHH
                                                             WHERE EHH.NREVENTOM = EH.NREVENTOM
                                                               AND EHH.NRORG = EH.NRORG
                                                               AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
               WHERE ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                 AND ITC.NRORG = CF.NRORG
                 AND ITC.NRVINCULOM = VM.NRVINCULOM
                 AND ITC.VREVENTOFOLHA > 0
                 AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) )
   AND EXISTS(SELECT 1 
                FROM VAB_BENEFICIARIO BF
                JOIN VAB_BENEFICIOM BM ON BM.NRORG = BF.NRORG
                                      AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                      AND BM.DTINICIOVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                      AND ( BM.DTFINALVIGENCIA >= :P_DTMESCOMPETENC OR BM.DTFINALVIGENCIA IS NULL )
                JOIN VAB_BENEFICIOH BH ON BH.NRORG = BM.NRORG
                                      AND BH.NRBENEFICIOM = BM.NRBENEFICIOM
                                      AND BH.DTMESCOMPETENC = ( SELECT *
                                                                  FROM ( SELECT H1.DTMESCOMPETENC
                                                                         FROM VAB_BENEFICIOH H1
                                                                         WHERE H1.NRORG = BH.NRORG
                                                                           AND H1.NRBENEFICIOM = BH.NRBENEFICIOM
                                                                           AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                         ORDER BY DTMESCOMPETENC DESC )
                                                                   WHERE ROWNUM = 1 )
               WHERE BF.NRORG = VM.NRORG
                 AND BF.NRVINCULOM = VM.NRVINCULOM
                 AND IT.NREVENTOM IN (BH.NREVETITULARVINC, BH.NREVENTOCOPART, BH.NREVEDEPEVINC, BH.NREVENTOCOPARTDEP)
              UNION ALL
              SELECT 1
                FROM FPA_VINCEVENTO VE
               WHERE VE.NRORG = VM.NRORG
                 AND VE.NRVINCULOM = VM.NRVINCULOM
                 AND VE.NRESTRUTURAM IS NOT NULL
                 AND VE.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                 AND ( VE.DTFIMVIGENCIA >= :P_DTMESCOMPETENC OR VE.DTFIMVIGENCIA IS NULL ) )
 GROUP BY VM.NRORG, VM.NRPESSOA
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_DTOCORRENCIA" => $dtocorrencia,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function verificaApuraBeneficio($nrorg, $nrvinculomlist) {
        $sql = <<<SQL
/*getDadosS1210planSaude-verificaApuraBeneficio*/
SELECT 1 AS APURABENEFICIO
  FROM VAB_APURABENEFICIO AB
 WHERE AB.NRORG = :P_NRORG
   AND INSTR(','||:P_NRVINCULOMLIST||',',','||AB.NRVINCULOM||',') > 0
   AND AB.NRCALCULOFOLHA = ( SELECT NRCALCULOFOLHA FROM FPA_CALCULOFOLHA AUX
                           WHERE AUX.NRORG = :P_NRORG
                             AND AUX.DTOCORRENCIA = :P_DTMESCOMPETENC
                             AND AUX.NRTPMODALIDCAL = 1
                             AND ROWNUM <= 1 /*apenas por segurança*/
                             AND AUX.NRTIPOMOVIMENT = 21 )
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRVINCULOMLIST" => $nrvinculomlist,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function getDadosPlanSaudeApuraBenef($nrorg, $nrcalculofolhalist, $nrvinculomlist) {
        $sql = <<<SQL
/*getDadosS1210PlanSaudeApuraBenef*/
SELECT 
  NRORG,
  NRBENEFICIOM,
  CDCNPJESTRUT cnpjOper,
  NMRAZSOCESTRUT,
  REPLACE(REPLACE(CDFEDERALESTRUT,'-',''),' ','') regANS,
  SUM(ROUND(VALOR,2)) vlrSaudeTit,
  1 AS APURABENEFICIO, :P_NRCALCULOFOLHALIST AS NRCALCULOFOLHALIST, :P_NRVINCULOMLIST AS NRVINCULOMLIST
FROM (SELECT
			AB.NRORG,
			AB.NRBENEFICIOM,
            EHB.CDCNPJESTRUT,
            EHB.NMRAZSOCESTRUT,
			EHB.CDFEDERALESTRUT,
			AB.VRAPURABENEFICIO VALOR
		/*Itens de cálculo*/
		FROM FPA_CALCULOFOLHA CF
		JOIN VAB_APURABENEFICIO AB ON AB.NRORG           = CF.NRORG
								  AND AB.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
		                          AND AB.DSTIPOBENEFICIO = 'V'
		/*Benefício*/
		JOIN VAB_BENEFICIARIO BF ON BF.NRORG            = AB.NRORG
								AND BF.NRBENEFICIOM     = AB.NRBENEFICIOM
								AND BF.NRVINCULOM       = AB.NRVINCULOM
								AND BF.NRPESSOA         = AB.NRPESSOA
                                AND BF.IDTPBENEFICIARIO = 'T'
		JOIN VAB_BENEFICIOH BH ON BH.NRORG          = AB.NRORG
							AND BH.NRBENEFICIOM   = AB.NRBENEFICIOM
							AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
														WHERE NRORG        = BH.NRORG
														AND NRBENEFICIOM = BH.NRBENEFICIOM
														AND DTMESCOMPETENC <= :P_DTMESCOMPETENC )
		/*Operadora do benefício Titular*/
		LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BH.NRORG
						AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
						AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
													WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
														AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
														AND NRORG           = EHB.NRORG)
		/**/
	   WHERE CF.NRORG = :P_NRORG
	     AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
	     AND CF.NRTIPOMOVIMENT = 21 /*Movimentos mensal*/
         AND CF.NRTPMODALIDCAL = 1 /*Real*/
         AND EHB.CDFEDERALESTRUT IS NOT NULL
		 AND INSTR(','||:P_NRVINCULOMLIST||',',','||AB.NRVINCULOM||',') > 0
	  UNION ALL 
      SELECT 
          BF.NRORG,
          BF.NRBENEFICIOM,
          EHB.CDCNPJESTRUT,
          EHB.NMRAZSOCESTRUT,
          EHB.CDFEDERALESTRUT,
          ICF.VREVENTOFOLHA VALOR
        FROM VAB_BENEFICIARIO BF
        /*Benefício*/
        JOIN VAB_BENEFICIOM BM ON BM.NRORG        = BF.NRORG
                              AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                              AND BM.IDATIVO      = 'S'
                              AND BM.DTINICIOVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                              AND ( BM.DTFINALVIGENCIA >= :P_DTMESCOMPETENC OR BM.DTFINALVIGENCIA IS NULL )
        JOIN VAB_BENEFICIOH BH ON BH.NRORG          = BM.NRORG
                              AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                              AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                        WHERE NRORG        = BH.NRORG
                                                          AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                          AND VAB_BENEFICIOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
        /*Cálculo*/
        JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = BF.NRORG
                                AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                                AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE(:P_DTMESCOMPETENC))
        /*Itens de cálculo*/
        JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                 AND ICF.NRVINCULOM     = BF.NRVINCULOM
                                 AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                 AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART, BH.NREVENTOCOPARTDEP) ) /*Parte co-participação*/
                                 AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
        /*Operadora do benefício Titular*/
        LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                           WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                             AND NRORG           = EHB.NRORG)
        WHERE BF.NRORG = :P_NRORG
          AND INSTR(','||:P_NRVINCULOMLIST||',',','||BF.NRVINCULOM||',') > 0
          AND BF.IDTPBENEFICIARIO = 'T'
          AND EHB.CDFEDERALESTRUT IS NOT NULL)
 WHERE VALOR > 0
 GROUP BY NRORG, NRBENEFICIOM, CDCNPJESTRUT, NMRAZSOCESTRUT, CDFEDERALESTRUT
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $nrcalculofolhalist,
            "P_NRVINCULOMLIST" => $nrvinculomlist,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosPlanSaudeVincEvento($nrorg, $nrcalculofolhalist, $nrvinculomlist) {
        $sql = <<<SQL
/* getDadosPlanSaudeVincEvento */
SELECT 
      NRORG,
      CDCNPJESTRUT cnpjOper,
      NMRAZSOCESTRUT,
      REPLACE(REPLACE(CDFEDERALESTRUT,'-',''),' ','') regANS,
      SUM(ROUND(VALOR,2)) vlrSaudeTit,
      0 AS APURABENEFICIO, :P_NRCALCULOFOLHALIST AS NRCALCULOFOLHALIST, :P_NRVINCULOMLIST AS NRVINCULOMLIST
    FROM (
          SELECT 
            EH1.NRORG,
            EH1.CDCNPJESTRUT,
            EH1.NMRAZSOCESTRUT,
            EH1.CDFEDERALESTRUT,
            ICF1.VREVENTOFOLHA VALOR
          FROM FPA_VINCEVENTO VEV1
          JOIN FPA_CALCULOFOLHA CF1 ON CF1.NRORG = VEV1.NRORG
                                   AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF1.NRCALCULOFOLHA||',') > 0
          JOIN ESTRUTURAM EM1 ON EM1.NRORG        = VEV1.NRORG
                             AND EM1.NRESTRUTURAM = VEV1.NRESTRUTURAM
                             AND EM1.NRTIPOESTRUTURA IN (13,19)
          LEFT JOIN ESTRUTURAH EH1 ON EH1.NRORG          = EM1.NRORG
                                  AND EH1.NRESTRUTURAM   = EM1.NRESTRUTURAM
                                  AND EH1.DTMESCOMPETENC = ( SELECT MAX(ESTRUTURAH1.DTMESCOMPETENC) FROM ESTRUTURAH ESTRUTURAH1
                                                             WHERE ESTRUTURAH1.NRESTRUTURAM = EH1.NRESTRUTURAM
                                                               AND ESTRUTURAH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                               AND ESTRUTURAH1.NRORG = EH1.NRORG)
          JOIN FPA_ITECALCFOLHA ICF1 ON ICF1.NRORG          = VEV1.NRORG
                                    AND ICF1.NRVINCULOM     = VEV1.NRVINCULOM
                                    AND ICF1.NREVENTOM      = VEV1.NREVENTOM
                                    AND ICF1.NRCALCULOFOLHA = CF1.NRCALCULOFOLHA
                                    AND ICF1.DTOCORRENCIA BETWEEN VEV1.DTINIVIGENCIA AND NVL(VEV1.DTFIMVIGENCIA, LAST_DAY( :P_DTMESCOMPETENC ))
          WHERE VEV1.NRORG = :P_NRORG
            AND INSTR(','||:P_NRVINCULOMLIST||',',','||VEV1.NRVINCULOM||',') > 0
            AND VEV1.NRESTRUTURAM IS NOT NULL
            AND VEV1.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
            AND ( VEV1.DTFIMVIGENCIA >= TO_DATE(:P_DTMESCOMPETENC) OR VEV1.DTFIMVIGENCIA IS NULL )
        UNION ALL 
          SELECT 
              EHB.NRORG,
              EHB.CDCNPJESTRUT,
              EHB.NMRAZSOCESTRUT,
              EHB.CDFEDERALESTRUT,
              ICF.VREVENTOFOLHA VALOR
            FROM VAB_BENEFICIARIO BF
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = BF.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            /*Cálculo*/
            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = BF.NRORG
                                    AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                                    AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                    AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE(:P_DTMESCOMPETENC))
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = BF.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
            /*Itens de cálculo*/
            JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                     AND ICF.NRVINCULOM     = BF.NRVINCULOM
                                     AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                     AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULARVINC, BH.NREVEDEPEVINC    ),  /*Parte do vínculo/dependente*/
                                                            DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP) ) /*Parte co-participação      */
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE BF.NRORG = :P_NRORG
            AND BF.IDTPBENEFICIARIO = 'T'
            AND EHB.CDFEDERALESTRUT IS NOT NULL
            AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
            AND INSTR(','||:P_NRVINCULOMLIST||',',','||BF.NRVINCULOM||',') > 0
    )
 WHERE VALOR > 0
 GROUP BY NRORG,
    CDCNPJESTRUT,
    NMRAZSOCESTRUT,
    CDFEDERALESTRUT
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $nrcalculofolhalist,
            "P_NRVINCULOMLIST" => $nrvinculomlist,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1210infoDepSau($params) {
        try {
            if ($params['APURABENEFICIO'] == 1) {
                $dados = $this->getDadosInfoDepSauApuraBenef($params['NRORG'], $params['NRCALCULOFOLHALIST'], $params['NRVINCULOMLIST'], $params['NRBENEFICIOM']);
            } else {
                $dados = $this->getDadosInfoDepSauVincEvento($params['NRORG'], $params['NRCALCULOFOLHALIST'], $params['NRVINCULOMLIST'], $params['NRBENEFICIOM']);
            }
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosInfoDepSauApuraBenef($nrorg, $nrcalculofolhalist, $nrvinculomlist, $nrbeneficiom) {
        $sql = <<<SQL
/*getDadosS1210InfoDepSauApuraBenef*/
SELECT 
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0') cpfDep,
      NMPESSOA,
      SUM(ROUND(VALORDEP,2)) vlrSaudeDep	
FROM (
      SELECT
			PEH.NRCPFPESSOA,
			PEH.NMPESSOA,
			AB.VRAPURABENEFICIO  VALORDEP
		/*Itens de cálculo*/
		FROM FPA_CALCULOFOLHA CF
		JOIN VAB_APURABENEFICIO AB ON AB.NRORG           = CF.NRORG
								  AND AB.NRCALCULOFOLHA  = CF.NRCALCULOFOLHA
		                          AND AB.DSTIPOBENEFICIO = 'V'
                                  AND AB.NRBENEFICIOM    = :P_NRBENEFICIOM
		/*Pessoa Geral*/
		JOIN GPE_PESSOAH PEH ON PEH.NRORG          = AB.NRORG
							AND PEH.NRPESSOA       = AB.NRPESSOA
                            AND PEH.DTMESCOMPETENC = ( SELECT *
                                                      FROM ( SELECT H1.DTMESCOMPETENC
                                                             FROM GPE_PESSOAH H1
                                                             WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                               AND H1.NRORG      = PEH.NRORG
                                                               AND H1.NRPESSOA = PEH.NRPESSOA
                                                             ORDER BY DTMESCOMPETENC DESC )
                                                       WHERE ROWNUM = 1 )
		/*Benefício*/
		JOIN VAB_BENEFICIARIO BF ON BF.NRORG            = AB.NRORG
								AND BF.NRBENEFICIOM     = AB.NRBENEFICIOM
								AND BF.NRVINCULOM       = AB.NRVINCULOM
								AND BF.NRPESSOA         = AB.NRPESSOA
								AND BF.IDTPBENEFICIARIO = 'D'
		/**/
	   WHERE CF.NRORG = :P_NRORG
	     AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
         AND CF.NRTIPOMOVIMENT = 21 /*Movimentos mensal*/
         AND CF.NRTPMODALIDCAL = 1 /*Real*/
	     AND INSTR(','||:P_NRVINCULOMLIST||',',','||AB.NRVINCULOM||',') > 0
	  UNION ALL 
      SELECT 
          PEH.NRCPFPESSOA,
          PEH.NMPESSOA,
          ICF.VREVENTOFOLHA  VALORDEP
        FROM VAB_BENEFICIARIO BF
        /*Benefício*/
        JOIN VAB_BENEFICIOM BM ON BM.NRORG        = BF.NRORG
                              AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                              AND BM.IDATIVO      = 'S'
                              AND BM.DTINICIOVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                              AND ( BM.DTFINALVIGENCIA >= :P_DTMESCOMPETENC OR BM.DTFINALVIGENCIA IS NULL )
        /*Cálculo*/
        JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = BF.NRORG
                                AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                                AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE(:P_DTMESCOMPETENC))
        JOIN VAB_BENEFICIOH BH ON BH.NRORG          = BM.NRORG
                              AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                              AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                        WHERE NRORG        = BH.NRORG
                                                          AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                          AND VAB_BENEFICIOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
        /*Itens de cálculo*/
        JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                 AND ICF.NRVINCULOM     = BF.NRVINCULOM
                                 AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                 AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP) ) /*Parte co-participação*/
                                 AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
        /*Pessoa Dependente*/
        JOIN GPE_PESSOA PE ON PE.NRORG    = BF.NRORG
                          AND PE.NRPESSOA = BF.NRPESSOA
        JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                            AND PEH.NRPESSOA       = PE.NRPESSOA
                            AND PEH.DTMESCOMPETENC = ( SELECT *
                                                      FROM ( SELECT H1.DTMESCOMPETENC
                                                             FROM GPE_PESSOAH H1
                                                             WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                               AND H1.NRORG      = PEH.NRORG
                                                               AND H1.NRPESSOA = PEH.NRPESSOA
                                                             ORDER BY DTMESCOMPETENC DESC )
                                                       WHERE ROWNUM = 1 )
        WHERE BF.NRORG = :P_NRORG
          AND INSTR(','||:P_NRVINCULOMLIST||',',','||BF.NRVINCULOM||',') > 0
          AND BF.NRBENEFICIOM = :P_NRBENEFICIOM
          AND BF.IDTPBENEFICIARIO = 'D')
 WHERE VALORDEP > 0
 GROUP BY LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0'), NMPESSOA
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRORG_PADRAO" => $this->environment->getNrorgPadrao(),
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $nrcalculofolhalist,
            "P_NRVINCULOMLIST" => $nrvinculomlist,
            "P_NRBENEFICIOM" => $nrbeneficiom,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosInfoDepSauVincEvento($nrorg, $nrcalculofolhalist, $nrvinculomlist) {
        $sql = <<<SQL
/* getDadosInfoDepSauVincEvento */
SELECT 
      LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0') cpfDep,
      NMPESSOA,
      SUM(ROUND(VALORDEP,2)) vlrSaudeDep
    FROM (
          SELECT 
              PEH.NRCPFPESSOA,
              PEH.NMPESSOA,
              ICF.VREVENTOFOLHA VALORDEP
            FROM VAB_BENEFICIARIO BF
            JOIN VAB_BENEFICIOM BM ON BM.NRORG        = BF.NRORG
                                  AND BM.NRBENEFICIOM = BF.NRBENEFICIOM
                                  AND BM.IDATIVO      = 'S'
            /*Cálculo*/
            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = BF.NRORG
                                    AND INSTR(','||:P_NRCALCULOFOLHALIST||',',','||CF.NRCALCULOFOLHA||',') > 0
                                    AND CF.DTOCORRENCIA >= TRUNC(BM.DTINICIOVIGENCIA, 'MM') /*Garante cálculo dentro da vigência do benefício*/
                                    AND CF.DTOCORRENCIA <= NVL(BM.DTFINALVIGENCIA, TO_DATE( :P_DTMESCOMPETENC))
            JOIN VAB_BENEFICIOH BH ON BH.NRORG          = BF.NRORG
                                  AND BH.NRBENEFICIOM   = BM.NRBENEFICIOM
                                  AND BH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH
                                                            WHERE NRORG        = BH.NRORG
                                                              AND NRBENEFICIOM = BH.NRBENEFICIOM
                                                              AND VAB_BENEFICIOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
            /*Itens de cálculo*/
            JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                     AND ICF.NRVINCULOM     = BF.NRVINCULOM
                                     AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                     AND ICF.NREVENTOM IN ( DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVETITULARVINC, BH.NREVEDEPEVINC    ),  /*Parte do vínculo/dependente*/
                                                            DECODE(BF.IDTPBENEFICIARIO, 'T', BH.NREVENTOCOPART,   BH.NREVENTOCOPARTDEP) ) /*Parte co-participação      */
            /*Pessoa Dependente*/
            JOIN GPE_PESSOA PE ON PE.NRORG    = BF.NRORG
                              AND PE.NRPESSOA = BF.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG          = PE.NRORG
                                AND PEH.NRPESSOA       = PE.NRPESSOA
                                AND PEH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                           WHERE NRORG           = PEH.NRORG
                                                             AND NRPESSOA        = PEH.NRPESSOA
                                                             AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC) )
            /*Operadora do benefício Titular*/
            LEFT JOIN ESTRUTURAH EHB ON EHB.NRORG          = BF.NRORG
                                    AND EHB.NRESTRUTURAM   = BH.NRESTRUTURAM
                                    AND EHB.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE NRESTRUTURAM    = EHB.NRESTRUTURAM
                                                                 AND NRORG           = EHB.NRORG)
            WHERE BF.NRORG = :P_NRORG
              AND BF.IDTPBENEFICIARIO = 'D'
              AND INSTR(','||:P_NRVINCULOMLIST||',',','||BF.NRVINCULOM||',') > 0
              AND EHB.CDFEDERALESTRUT IS NOT NULL
              AND ICF.DTOCORRENCIA BETWEEN FIRST_DAY(BF.DTINSCBENEFICIARIO) AND NVL(BF.DTCANCBENEFICIARIO,ICF.DTOCORRENCIA)
    )
 WHERE VALORDEP > 0
 GROUP BY LPAD(NVL(REPLACE(REPLACE(NRCPFPESSOA,'.',''),'-',''), '0'), 11, '0'),
      NMPESSOA
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->environment->getDtCompetencia(),
            "P_NRCALCULOFOLHALIST" => $nrcalculofolhalist,
            "P_NRVINCULOMLIST" => $nrvinculomlist,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
}