<?php
namespace HCM\VAB\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Folha\Entities\VabBeneficiario;
use Folha\Entities\FpaVincevento;
use HCM\Util\Messages;
use HCM\Util\FPA;

class BeneficioRepository {

    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getBeneficiarioPorEvento($parameters, $conditions) {
        $nrorg  = $parameters[0];
        $dtmescompetenc  = $parameters[1];
        $nrorgpadrao  = $parameters[2]; 
        $nrbeneficiom = $parameters[3];
        $query = <<<SQL

        
SELECT 
  * 
FROM 
  (
    SELECT 
      BNE.NRORG, 
      BNE.NRBENEFICIARIO, 
      BNE.NRBENEFICIOM, 
      BNE.NRVINCULOM, 
      BNE.NRPESSOA, 
      BNE.NREVENTOM, 
      BNE.NRINTEGTRANSPM, 
      BNE.NRVALORREFERENCIAM, 
      BNE.NRVINCEVENTO, 
      BNE.NRINSCBENEFICIARIO, 
      TO_CHAR(
        BNE.DTCANCBENEFICIARIO, 'DD/MM/YYYY'
      ) AS DTCANCBENEFICIARIO, 
      TO_CHAR(
        BNE.DTINSCBENEFICIARIO, 'DD/MM/YYYY'
      ) AS DTINSCBENEFICIARIO, 
      BNE.QTBENEFICIO, 
      BNE.VRBENEFICIO, 
      BNE.IDTPBENEFICIARIO, 
      BNE.IDVALORDIFEBENEF, 
      BNE.DSOBSBENEFICIARIO, 
      BNE.IDATIVO, 
      BNE.NRORGINCLUSAO, 
      BNE.DTINCLUSAO, 
      BNE.CDOPERINCLUSAO, 
      BNE.NRORGULTATU, 
      BNE.DTULTATU, 
      BNE.CDOPERULTATU, 
      BNE.SUBSIDIO100, 
      BNE.VRPERCSUBSIDIO, 
      VIN.NMVINCULOM, 
      VIN.NRPESSOA AS NRPESSOAVINC, 
      PSH.NMPESSOA, 
      PSH.DTNASCPESSOA AS DTNASCIMENTO, 
      EVH.NMEVENTOH, 
      ITH.VRSALDOULTCONSULTA, 
      VRM.DSREFERENCIA, 
      EVHI.NMEVENTOH AS NMVINCEVENTOH, 
      INTEG_H.CDINTEGTRANSP 
    FROM 
      VAB_BENEFICIARIO BNE 
      INNER JOIN GPE_VINCULOM VIN ON VIN.NRVINCULOM = BNE.NRVINCULOM 
      AND VIN.NRORG = BNE.NRORG 
      INNER JOIN GPE_PESSOAH PSH ON PSH.NRPESSOA = BNE.NRPESSOA 
      AND PSH.NRORG = BNE.NRORG 
      AND PSH.DTMESCOMPETENC = (
        SELECT 
          DTMESCOMPETENC 
        FROM 
          (
            SELECT 
              PSAH.DTMESCOMPETENC 
            FROM 
              GPE_PESSOAH PSAH 
            WHERE 
              PSAH.NRORG = PSH.NRORG 
              AND PSAH.NRPESSOA = PSH.NRPESSOA 
              AND PSAH.DTMESCOMPETENC <= :DTMESCOMPETENC 
            ORDER BY 
              PSAH.DTMESCOMPETENC DESC
          ) 
        WHERE 
          ROWNUM = 1
      ) 
      INNER JOIN FPA_EVENTOH EVH ON EVH.NREVENTOM = BNE.NREVENTOM 
      AND (
        EVH.NRORG = BNE.NRORG 
        OR EVH.NRORG = :NRORG_PADRAO
      ) 
      AND EVH.DTMESCOMPETENC = (
        SELECT 
          DTMESCOMPETENC 
        FROM 
          (
            SELECT 
              FEVH.DTMESCOMPETENC 
            FROM 
              FPA_EVENTOH FEVH 
            WHERE 
              FEVH.NRORG = EVH.NRORG 
              AND FEVH.NREVENTOM = EVH.NREVENTOM 
              AND FEVH.DTMESCOMPETENC <= :DTMESCOMPETENC 
            ORDER BY 
              FEVH.DTMESCOMPETENC DESC
          ) 
        WHERE 
          ROWNUM = 1
      ) 
      LEFT JOIN VAB_INTEGTRANSPH ITH ON ITH.NRINTEGTRANSPM = BNE.NRINTEGTRANSPM 
      AND ITH.NRORG = BNE.NRORG 
      AND ITH.DTMESCOMPINTEG = (
        SELECT 
          MAX(ITEH.DTMESCOMPINTEG) 
        FROM 
          VAB_INTEGTRANSPH ITEH 
        WHERE 
          ITEH.NRORG = ITH.NRORG 
          AND ITEH.NRINTEGTRANSPM = ITH.NRINTEGTRANSPM 
          AND ITEH.DTMESCOMPINTEG <= :DTMESCOMPETENC
      ) 
      LEFT JOIN FPA_VALORREFERENCIAM VRM ON VRM.NRVALORREFERENCIAM = BNE.NRVALORREFERENCIAM 
      AND (
        VRM.NRORG = BNE.NRORG 
        OR VRM.NRORG = :NRORG_PADRAO
      ) 
      LEFT JOIN FPA_VINCEVENTO VINE ON VINE.NRVINCEVENTO = BNE.NRVINCEVENTO 
      AND VINE.NRORG = BNE.NRORG 
      LEFT JOIN FPA_EVENTOH EVHI ON EVHI.NREVENTOM = VINE.NREVENTOM 
      AND (
        EVHI.NRORG = BNE.NRORG 
        OR EVHI.NRORG = :NRORG_PADRAO
      ) 
      AND EVHI.DTMESCOMPETENC = (
        SELECT 
          DTMESCOMPETENC 
        FROM 
          (
            SELECT 
              FEVH.DTMESCOMPETENC 
            FROM 
              FPA_EVENTOH FEVH 
            WHERE 
              FEVH.NRORG = EVHI.NRORG 
              AND FEVH.NREVENTOM = EVHI.NREVENTOM 
              AND FEVH.DTMESCOMPETENC <= :DTMESCOMPETENC 
            ORDER BY 
              FEVH.DTMESCOMPETENC DESC
          ) 
        WHERE 
          ROWNUM = 1
      ) 
      LEFT JOIN VAB_INTEGTRANSPH INTEG_H ON INTEG_H.NRORG = BNE.NRORG 
      AND INTEG_H.NRINTEGTRANSPM = BNE.NRINTEGTRANSPM 
      AND INTEG_H.DTMESCOMPINTEG = (
        SELECT 
          MAX(INTEG_H2.DTMESCOMPINTEG) 
        FROM 
          VAB_INTEGTRANSPH INTEG_H2 
        WHERE 
          INTEG_H2.NRORG = INTEG_H.NRORG 
          AND INTEG_H2.NRINTEGTRANSPM = INTEG_H.NRINTEGTRANSPM 
          AND INTEG_H2.DTMESCOMPINTEG <= :DTMESCOMPETENC
      ) 
    WHERE 
      BNE.NRORG = :NRORG 
      AND NRBENEFICIOM = :NRBENEFICIOM 
    ORDER BY 
      VIN.NMVINCULOM, 
      PSH.NMPESSOA, 
      BNE.NREVENTOM
  ) 
WHERE 
  1 = 1 $conditions
SQL;

        return $this->connection->fetchAll($query, array("DTMESCOMPETENC" => $dtmescompetenc,
                                                         "NRORG"            => $nrorg,
                                                         "NRORG_PADRAO" => $nrorgpadrao,
                                                         "NRBENEFICIOM" => $nrbeneficiom));
    }
    
    public function getTipoBeneficioGerencialVigente($nrorg, $nrestruturageren, $dtmescompetenc){
        $query = <<<SQL

        
SELECT * FROM TPBENEFICIOGERENCIAL WHERE NRORG = :P_NRORG AND NRESTRUTGEREN = :P_NRESTRUTGEREN AND DTINIVIGENCIA <= :P_DTMESCOMPETENC AND (DTFIMVIGENCIA >= LAST_DAY(:P_DTMESCOMPETENC) OR DTFIMVIGENCIA IS NULL) AND IDATIVO = 'S'
    
SQL;
        
        return $this->connection->fetchAll($query, array("P_NRORG"              => $nrorg,
                                                         "P_NRESTRUTGEREN"      => $nrestruturageren,
                                                         "P_DTMESCOMPETENC"     => $dtmescompetenc)
                                                         );
                                                         
    }
    
    public function getTipoBeneficioGerencialExistente($nrorg, $nrtipobeneficio, $nrestruturageren,$nrtpbeneficiogeren){
        $query = <<<SQL

        
SELECT * FROM TPBENEFICIOGERENCIAL WHERE NRORG = :P_NRORG AND NRTIPOBENEFICIO = :P_NRTIPOBENEFICIO AND NRESTRUTGEREN = :P_NRESTRUTGEREN AND (NRTPBENEFICIOGERENCIAL <> :P_NRTPBENEFICIOGEREN OR :P_NRTPBENEFICIOGEREN IS NULL)
    
SQL;
        
        return $this->connection->fetchAll($query, array("P_NRORG"              => $nrorg,
                                                         "P_NRTIPOBENEFICIO"    => $nrtipobeneficio,
                                                         "P_NRESTRUTGEREN"      => $nrestruturageren,
                                                         "P_NRTPBENEFICIOGEREN" => $nrtpbeneficiogeren)
                                                         );
                                                         
    }

    public function getBeneficiario($parameters, $conditions) { 
        
        $nrorg  = $parameters[0];
        $dtmescompetenc  = $parameters[1];
        $nrorgpadrao  = $parameters[2];
        $nrbeneficiom = $parameters[3];
        $query = <<<SQL
SELECT * FROM (        
    SELECT  BNE.NRORG,
            BNE.NRBENEFICIARIO,
            BNE.NRBENEFICIOM,
            BNE.NRVINCULOM,
            BNE.NRPESSOA,
            BNE.NREVENTOM,
            BNE.NRINTEGTRANSPM,
            BNE.NRVALORREFERENCIAM,
            BNE.NRVINCEVENTO,
            BNE.NRINSCBENEFICIARIO,
            TO_CHAR(BNE.DTCANCBENEFICIARIO, 'DD/MM/YYYY') AS DTCANCBENEFICIARIO,
            TO_CHAR(BNE.DTINSCBENEFICIARIO, 'DD/MM/YYYY') AS DTINSCBENEFICIARIO,
            BNE.QTBENEFICIO,
            BNE.VRBENEFICIO,
            BNE.IDTPBENEFICIARIO,
            BNE.IDVALORDIFEBENEF,
            BNE.DSOBSBENEFICIARIO,
            BNE.IDATIVO,
            BNE.NRORGINCLUSAO,
            BNE.DTINCLUSAO,
            BNE.CDOPERINCLUSAO,
            BNE.NRORGULTATU,
            BNE.DTULTATU,
            BNE.CDOPERULTATU,
            BNE.SUBSIDIO100,
            BNE.VRPERCSUBSIDIO,
            VIN.NMVINCULOM,
            VIN.NRPESSOA AS NRPESSOAVINC,
            PSH.NMPESSOA, 
            PSH.DTNASCPESSOA AS DTNASCIMENTO,
            INTEG_H.CDINTEGTRANSP
           
    FROM VAB_BENEFICIARIO BNE
    
    INNER JOIN GPE_VINCULOM VIN ON VIN.NRVINCULOM = BNE.NRVINCULOM
                                   AND VIN.NRORG = BNE.NRORG
    INNER JOIN GPE_VINCULOH VH ON                 
                VH.NRVINCULOM = VIN.NRVINCULOM AND
                VH.NRORG = VIN.NRORG AND 
                VH.DTMESCOMPETENC = ( SELECT DTMESCOMPETENC FROM (SELECT VHH.DTMESCOMPETENC
                                             FROM GPE_VINCULOH VHH
                                            WHERE VHH.NRORG      = VH.NRORG
                                              AND VHH.NRVINCULOM = VH.NRVINCULOM
                                              AND VHH.DTMESCOMPETENC <= :DTMESCOMPETENC
                                              ORDER BY VHH.DTMESCOMPETENC DESC)
                                              WHERE ROWNUM = 1
                                              )
    INNER JOIN GPE_PESSOAH PSH ON  PSH.NRPESSOA = BNE.NRPESSOA
                                   AND PSH.NRORG = BNE.NRORG
                                   AND PSH.DTMESCOMPETENC =
                                      ( SELECT MAX(PSAH.DTMESCOMPETENC)
                                        FROM GPE_PESSOAH PSAH
                                        WHERE PSAH.NRORG = PSH.NRORG
                                          AND PSH.NRPESSOA = PSAH.NRPESSOA
                                          AND PSAH.DTMESCOMPETENC <= :DTMESCOMPETENC
                                      )
                                      
    LEFT JOIN VAB_INTEGTRANSPH INTEG_H  ON INTEG_H.NRORG = BNE.NRORG
                                        AND INTEG_H.NRINTEGTRANSPM = BNE.NRINTEGTRANSPM
                                        AND INTEG_H.DTMESCOMPINTEG = 
                                          ( SELECT MAX(INTEG_H2.DTMESCOMPINTEG)
                                            FROM VAB_INTEGTRANSPH INTEG_H2
                                            WHERE INTEG_H2.NRORG = INTEG_H.NRORG
                                              AND INTEG_H2.NRINTEGTRANSPM = INTEG_H.NRINTEGTRANSPM
                                              AND INTEG_H2.DTMESCOMPINTEG <= :DTMESCOMPETENC
                                          )

                                      
    WHERE BNE.NRORG = :NRORG
    AND BNE.NREVENTOM IS NULL
    AND NRBENEFICIOM = :NRBENEFICIOM
    AND ( INSTR(','||:P_NRESTRUTLEGALOPER||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGALOPER IS NULL )
    AND ( INSTR(','||:P_NRESTRUTGERENOPER||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGERENOPER IS NULL )
    ORDER BY
      VIN.NMVINCULOM, PSH.NMPESSOA, BNE.NREVENTOM
)
WHERE 1=1 $conditions
SQL;
        return $this->connection->fetchAll($query, array("DTMESCOMPETENC" => $dtmescompetenc,
                                                         "NRORG"          => $nrorg,
                                                         "NRORG_PADRAO"   => $nrorgpadrao,
                                                         "P_NRESTRUTLEGALOPER"   => FPA::getNrestrutlegalOper(),
                                                         "P_NRESTRUTGERENOPER"   => FPA::getNrestrutgerenOper(),
                                                         "NRBENEFICIOM"   => $nrbeneficiom));
    }
    
    public function getBeneficioPorVinculo($mesCompetencia, $nrorg, $idtpbeneficiario, $nrvinculom, $nrpessoadep, $nrorgpadrao, $filtro){
    
    $params = array('DTMESCOMPETENC'     => $mesCompetencia,
                    'NRORG'              => $nrorg,
                    'P_IDTPBENEFICIARIO' => $idtpbeneficiario,
                    'P_NRVINCULOM'       => $nrvinculom,
                    'P_NRPESSOA_DEP'     => $nrpessoadep,
                    'P_NRORG_PADRAO'     => $nrorgpadrao);    
        
    $query = "
SELECT * FROM( 
    SELECT VAB_BENEFICIARIO.NRBENEFICIARIO,
            VAB_BENEFICIARIO.DSOBSBENEFICIARIO,
            TO_CHAR(VAB_BENEFICIARIO.DTCANCBENEFICIARIO, 'DD/MM/YYYY') AS DTCANCBENEFICIARIO,
            TO_CHAR(VAB_BENEFICIARIO.DTINSCBENEFICIARIO, 'DD/MM/YYYY') AS DTINSCBENEFICIARIO,
            VAB_BENEFICIARIO.NRINSCBENEFICIARIO,
            VAB_BENEFICIARIO.NRINTEGTRANSPM,
            ITH.CDINTEGTRANSP,
            VAB_BENEFICIARIO.QTBENEFICIO,
            VAB_BENEFICIOM.NRORG,
            VAB_BENEFICIOH.NRBENEFICIOH,
            VAB_BENEFICIOM.NRBENEFICIOM,
            VAB_BENEFICIOH.DSBENEFICIO,
            VAB_BENEFICIOM.IDATIVO,
            VAB_BENEFICIOM.DTINICIOVIGENCIA,
            VAB_BENEFICIOM.DTFINALVIGENCIA,
            VAB_BENEFICIOH.DTREFERENCIA,
            TPBENEFICIO.DSTPBENEFICIO,
            FORMABENEFICIO.DSFORMABENEFICIO,
            ESTRUTURAH.NMESTRUTURAH,
            VAB_BENEFICIOH.TPPERIODOBENEF,
            VAB_BENEFICIOH.NRTABELAFOLHAPRI,
            VAB_BENEFICIOH.NRTABELAFOLHASEC,
            (SELECT LISTAGG(TFP.NMTABELAFOLHA, ', ') WITHIN GROUP(ORDER BY TFP.NMTABELAFOLHA)
               FROM FPA_TABELAFOLHA TFP
              WHERE INSTR(', '
                    || VAB_BENEFICIOH.NRTABELAFOLHAPRI
                    || ', ',', '
                    || TFP.NRTABELAFOLHA
                    || ', ') > 0
                AND (TFP.NRORG = VAB_BENEFICIOH.NRORG OR TFP.NRORG =:P_NRORG_PADRAO)) NMTABELAFOLHAPRI,
            (SELECT LISTAGG(TFS.NMTABELAFOLHA,', ') WITHIN GROUP(ORDER BY TFS.NMTABELAFOLHA)
               FROM FPA_TABELAFOLHA TFS
              WHERE INSTR(', '
                    || VAB_BENEFICIOH.NRTABELAFOLHASEC
                    || ', ',', '
                    || TFS.NRTABELAFOLHA
                    || ', ') > 0
                AND (TFS.NRORG = VAB_BENEFICIOH.NRORG OR TFS.NRORG =:P_NRORG_PADRAO)) NMTABELAFOLHASEC,
            VAB_BENEFICIOH.NRMESANIVERSARIO,
            VAB_BENEFICIOH.NRDIAVENCBOLETO,
            VAB_BENEFICIOH.NRIDADEMAXSUBFILHOS,
            VAB_BENEFICIOH.SEXOSUBSIDIOFILHO,
            VAB_BENEFICIOH.NRIDADEMAXSUBDEP,
            VAB_BENEFICIOH.SEXOSUBSIDIODEP
        FROM VAB_BENEFICIOM
        JOIN VAB_BENEFICIOH ON VAB_BENEFICIOM.NRBENEFICIOM = VAB_BENEFICIOH.NRBENEFICIOM
                                AND VAB_BENEFICIOM.NRORG = VAB_BENEFICIOH.NRORG                            
                                AND VAB_BENEFICIOH.DTMESCOMPETENC = ( SELECT MAX(BENH.DTMESCOMPETENC)
                                                                        FROM VAB_BENEFICIOH BENH
                                                                       WHERE BENH.NRORG = VAB_BENEFICIOH.NRORG
                                                                         AND VAB_BENEFICIOH.NRBENEFICIOM = BENH.NRBENEFICIOM
                                                                         AND BENH.DTMESCOMPETENC <= :DTMESCOMPETENC)
        JOIN ESTRUTURAM ON VAB_BENEFICIOH.NRESTRUTURAM = ESTRUTURAM.NRESTRUTURAM
                            AND VAB_BENEFICIOM.NRORG = ESTRUTURAM.NRORG
        LEFT JOIN ESTRUTURAH ON ESTRUTURAM.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                                AND ESTRUTURAM.NRORG= ESTRUTURAH.NRORG
                                AND ESTRUTURAH.DTMESCOMPETENC = ( SELECT MAX(ESTH.DTMESCOMPETENC)
                                                                    FROM ESTRUTURAH ESTH
                                                                   WHERE ESTH.NRORG = ESTRUTURAH.NRORG
                                                                     AND ESTRUTURAH.NRESTRUTURAM = ESTH.NRESTRUTURAM
                                                                     AND ESTH.DTMESCOMPETENC <= :DTMESCOMPETENC)
        JOIN FORMABENEFICIO ON VAB_BENEFICIOH.NRFORMABENEFICIO = FORMABENEFICIO.NRFORMABENEFICIO
                                AND FORMABENEFICIO.NRORG = VAB_BENEFICIOM.NRORG
        JOIN TPBENEFICIO ON VAB_BENEFICIOH.NRTPBENEFICIO = TPBENEFICIO.NRTPBENEFICIO
                            AND TPBENEFICIO.NRORG = VAB_BENEFICIOM.NRORG
        JOIN VAB_BENEFICIARIO ON VAB_BENEFICIARIO.NRBENEFICIOM = VAB_BENEFICIOM.NRBENEFICIOM
                                 AND VAB_BENEFICIARIO.NRORG = VAB_BENEFICIOM.NRORG    
                                 AND (VAB_BENEFICIARIO.NRPESSOA = :P_NRPESSOA_DEP OR :P_NRPESSOA_DEP IS NULL)
        LEFT JOIN VAB_INTEGTRANSPH ITH ON ITH.NRORG          = VAB_BENEFICIARIO.NRORG
                                      AND ITH.NRINTEGTRANSPM = VAB_BENEFICIARIO.NRINTEGTRANSPM
                                      AND ITH.IDATIVO        = 'S'
                                      AND ITH.DTMESCOMPINTEG = ( SELECT MAX(DTMESCOMPINTEG) FROM VAB_INTEGTRANSPH
                                                                 WHERE DTMESCOMPINTEG <= :DTMESCOMPETENC
                                                                   AND NRORG          = VAB_BENEFICIARIO.NRORG
                                                                   AND NRINTEGTRANSPM = ITH.NRINTEGTRANSPM )
        WHERE VAB_BENEFICIARIO.NRORG = :NRORG
            AND VAB_BENEFICIARIO.NREVENTOM IS NULL
            AND (VAB_BENEFICIARIO.IDTPBENEFICIARIO = :P_IDTPBENEFICIARIO OR (:P_IDTPBENEFICIARIO IS NULL AND VAB_BENEFICIARIO.IDTPBENEFICIARIO IN ('T','D')))
            AND VAB_BENEFICIARIO.NRVINCULOM = :P_NRVINCULOM
            AND ( VAB_BENEFICIOM.DTFINALVIGENCIA IS NULL OR VAB_BENEFICIOM.DTFINALVIGENCIA > LAST_DAY(TO_DATE(:DTMESCOMPETENC, 'dd/mm/YYYY')) )
    ) A 
WHERE 1 = 1".$filtro;    

        return $this->connection->fetchAll($query, $params);
    } 
    
    public function retornaBefeficiarioVinculo($nrorg, $nrorgpadrao, $nrvinculom, $mescompetencia, $idtpbeneficiario, $idativo, $filtro){
        
$query = <<<SQL
SELECT * 
             FROM (SELECT VAB_BENEFICIARIO.*,
                          ITH.CDINTEGTRANSP,
                          --VAB_BENEFICIOM.NRORG,
                          VAB_BENEFICIOH.NRBENEFICIOH,
                          --VAB_BENEFICIOM.NRBENEFICIOM,
                          VAB_BENEFICIOH.DSBENEFICIO,
                          --VAB_BENEFICIOM.IDATIVO,
                          VAB_BENEFICIOM.DTINICIOVIGENCIA,
                          VAB_BENEFICIOM.DTFINALVIGENCIA,
                          VAB_BENEFICIOH.DTREFERENCIA,
                          VAB_BENEFICIOH.TPPERIODOBENEF,
                          VAB_BENEFICIOH.NRTABELAFOLHAPRI,
                          VAB_BENEFICIOH.NRTABELAFOLHASEC,
                          (SELECT LISTAGG(TFP.NMTABELAFOLHA, ', ') WITHIN GROUP(ORDER BY TFP.NMTABELAFOLHA)
                             FROM FPA_TABELAFOLHA TFP
                            WHERE INSTR(', '
                                  || VAB_BENEFICIOH.NRTABELAFOLHAPRI
                                  || ', ',', '
                                  || TFP.NRTABELAFOLHA
                                  || ', ') > 0
                              AND (TFP.NRORG = VAB_BENEFICIOH.NRORG OR TFP.NRORG =:P_NRORG_PADRAO)) NMTABELAFOLHAPRI,
                          (SELECT LISTAGG(TFS.NMTABELAFOLHA,', ') WITHIN GROUP(ORDER BY TFS.NMTABELAFOLHA)
                             FROM FPA_TABELAFOLHA TFS
                            WHERE INSTR(', '
                                  || VAB_BENEFICIOH.NRTABELAFOLHASEC
                                  || ', ',', '
                                  || TFS.NRTABELAFOLHA
                                  || ', ') > 0
                              AND (TFS.NRORG = VAB_BENEFICIOH.NRORG OR TFS.NRORG =:P_NRORG_PADRAO)) NMTABELAFOLHASEC,
                          VAB_BENEFICIOH.NRMESANIVERSARIO,
                          VAB_BENEFICIOH.NRDIAVENCBOLETO,
                          VAB_BENEFICIOH.NRIDADEMAXSUBFILHOS,
                          VAB_BENEFICIOH.SEXOSUBSIDIOFILHO,
                          VAB_BENEFICIOH.NRIDADEMAXSUBDEP,
                          VAB_BENEFICIOH.SEXOSUBSIDIODEP,
                          --GPE_VINCULOM.NRVINCULOM,
                          GPE_VINCULOM.NMVINCULOM,
                          --GPE_PESSOA.NRPESSOA,
                          GPE_PESSOAH.NMPESSOA
                     FROM VAB_BENEFICIARIO
                     JOIN VAB_BENEFICIOM  ON VAB_BENEFICIARIO.NRBENEFICIOM = VAB_BENEFICIOM.NRBENEFICIOM
                                         AND (VAB_BENEFICIOM.NRORG = VAB_BENEFICIARIO.NRORG OR VAB_BENEFICIOM.NRORG = :P_NRORG_PADRAO)
                     JOIN VAB_BENEFICIOH ON VAB_BENEFICIOM.NRBENEFICIOM = VAB_BENEFICIOH.NRBENEFICIOM
                                        AND VAB_BENEFICIOM.NRORG = VAB_BENEFICIOH.NRORG                            
                                        AND VAB_BENEFICIOH.DTMESCOMPETENC = ( SELECT MAX(BENH.DTMESCOMPETENC)
                                                                                FROM VAB_BENEFICIOH BENH
                                                                               WHERE BENH.NRORG = VAB_BENEFICIOH.NRORG
                                                                                 AND VAB_BENEFICIOH.NRBENEFICIOM = BENH.NRBENEFICIOM
                                                                                 AND BENH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                     JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = VAB_BENEFICIARIO.NRORG
                                      AND GPE_VINCULOM.NRVINCULOM = VAB_BENEFICIARIO.NRVINCULOM
                     JOIN GPE_VINCULOH ON GPE_VINCULOH.NRORG = GPE_VINCULOM.NRORG
                                      AND GPE_VINCULOH.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                      AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(VH.DTMESCOMPETENC)
                                                                           FROM GPE_VINCULOH VH
                                                                          WHERE VH.NRORG = GPE_VINCULOH.NRORG
                                                                            AND VH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                            AND VH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                     JOIN GPE_PESSOA ON GPE_PESSOA.NRORG = VAB_BENEFICIARIO.NRORG
                                    AND GPE_PESSOA.NRPESSOA = VAB_BENEFICIARIO.NRPESSOA
                     JOIN GPE_PESSOAH ON GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
                                     AND GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
                                     AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(PH.DTMESCOMPETENC)
                                                                         FROM GPE_PESSOAH PH
                                                                        WHERE PH.NRORG = GPE_PESSOAH.NRORG
                                                                          AND PH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                                          AND PH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                LEFT JOIN VAB_INTEGTRANSPH ITH ON ITH.NRORG          = VAB_BENEFICIARIO.NRORG
                                              AND ITH.NRINTEGTRANSPM = VAB_BENEFICIARIO.NRINTEGTRANSPM
                                              AND ITH.IDATIVO        = 'S'
                                              AND ITH.DTMESCOMPINTEG = ( SELECT MAX(DTMESCOMPINTEG) 
                                                                           FROM VAB_INTEGTRANSPH
                                                                          WHERE DTMESCOMPINTEG <= :P_DTMESCOMPETENC
                                                                            AND NRORG          = VAB_BENEFICIARIO.NRORG
                                                                            AND NRINTEGTRANSPM = ITH.NRINTEGTRANSPM )
                    WHERE VAB_BENEFICIARIO.NRORG = :P_NRORG
                      AND VAB_BENEFICIARIO.NREVENTOM IS NULL
                      AND ((VAB_BENEFICIARIO.IDTPBENEFICIARIO IN ('T','D') AND :P_IDTPBENEFICIARIO IS NULL) OR VAB_BENEFICIARIO.IDTPBENEFICIARIO = :P_IDTPBENEFICIARIO)  
                      AND (VAB_BENEFICIARIO.IDATIVO = :P_IDATIVO OR :P_IDATIVO IS NULL)  
                      AND VAB_BENEFICIARIO.NRVINCULOM = :P_NRVINCULOM
                      AND ( VAB_BENEFICIOM.DTFINALVIGENCIA IS NULL OR VAB_BENEFICIOM.DTFINALVIGENCIA > LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'dd/mm/YYYY')))) A
            WHERE 1 = 1 $filtro
        
SQL;
        $params = array('P_DTMESCOMPETENC'   => $mescompetencia,
                        'P_NRORG'            => $nrorg,
                        'P_NRVINCULOM'       => $nrvinculom,
                        'P_NRORG_PADRAO'     => $nrorgpadrao,
                        'P_IDATIVO'          => $idativo,    
                        'P_IDTPBENEFICIARIO' => $idtpbeneficiario);    
                
        return $this->connection->fetchAll($query, $params);
    }
} 
